'******************************************************************************
' Copyright (c) 2013 Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

  DOUBLE_QUOTE = $22

OBJ
  c : "clibsd"
  sys : "sysdefs"
  vs : "varsubs"

PUB main(argc, argv) | argi
  c.enter

  ' Print if no parms
  if argc < 2
    PrintAliases
    c.exit(0)

  repeat argi from 1 to argc - 1
    ProcessParm(long[argv][argi])

  c.exit(0)

PUB ProcessParm(name) | ptr, len1, len2, space, value

  ' Check for "=" and get value
  value := vs.FindChar(name, "=")
  ifnot byte[value]
    return
  byte[value++] := 0

  ' Check if variable already exists
  if (ptr := vs.FindAlias(name))
    ptr := vs.RemoveEntry(ptr)
  else
    ptr := vs.FindEnd

  ' Check if space is available
  space := sys#environ_vars_end - ptr + 1
  len1 := strsize(name)
  len2 := strsize(value)
  if space - len1 - len2 - 4 < 50
    c.printf2(string("space = %d, need = %d\n"), space, len1 + len2 + 4)
  if (space < len1 + len2 + 4)
    c.printf0(string("Not enough variable space\n"))
    c.exit(1)

  ' Add alias
  byte[ptr++] := VS#ALIAS_FLAG
  c.strcpy(ptr, name)
  ptr += len1 + 1
  c.strcpy(ptr, value)
  ptr += len2 + 1
  byte[ptr] := 0

{
PUB usage
  c.printf0(string("usage: alias [var[=[value]]...]\n"))
  c.exit(1)
}

PUB PrintAliases | ptr
  ptr := sys#environ_vars
  repeat while byte[ptr]
    ptr := PrintAlias(ptr)

PUB PrintAlias(ptr) | scope, name, value
  scope := byte[ptr++]
  name := ptr
  ptr += strsize(ptr) + 1
  value := ptr
  ptr += strsize(ptr) + 1
  if scope == "A"
    c.printf2(string("alias %s=", DOUBLE_QUOTE, "%s", DOUBLE_QUOTE, "\n"), name, value)
  return ptr

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
