'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c : "clibsd"

PUB main(argc, argv) | ptr, fname, value, setmask, setflag, bitpos
  c.enter

  if argc <> 3
    usage

  ptr := long[argv][1]
  fname := long[argv][2]

  setmask := c.getmod(fname)

  if (setmask == -1)
    nofile(fname)

  'Convert from FAT to UNIX format
  setmask := ((setmask&16)>>1) | 4 | (((setmask&1)^1)<<1) | ((setmask&32)>>5)

  if byte[ptr] => "0" AND byte[ptr] =< "7"
    c.sscanf1(ptr, string("%o"), @value)

    ' Check for undocumented 76543210XX code to include directory bit
    if (value & !15) == %111_110_101_100_011_010_001_000_000_000
      setmask := value
    elseifnot value & !7
      setmask := (setmask & 8) | value
    else
      usage

    'Convert from UNIX to FAT format
    setmask := ((setmask&8)<<1) | ((setmask&1)<<5) | (((setmask&2)>>1)^1)
    c.chmod(fname, setmask)
    c.exit(0)

  if byte[ptr] <> "+" AND byte[ptr] <> "-"
    usage

  setflag := 1
  repeat while byte[ptr]
    value := byte[ptr++]
    if value == "+"
      setflag := 1
      next
    elseif value == "-"
      setflag := 0
      next
    elseif value == "x"
      bitpos := 1
    elseif value == "w"
      bitpos := 2
    elseif value == "r"
      bitpos := 4
    'elseif value == "d"
      'bitpos := 8
    else
      usage

    if setflag
      setmask |= bitpos
    else
      setmask &= (bitpos ^ %1111)

  'Convert from UNIX to FAT format
  setmask := ((setmask&8)<<1) | ((setmask&1)<<5) | (((setmask&2)>>1)^1)

  c.chmod(fname, setmask)

  c.exit(0)

PUB nofile(fname)
  c.printf1(string("Could not find %s\n"), fname)
  c.exit(0)

PUB usage
  c.printf0(string("usage: chmod mode file\n"))
  c.printf0(string("  mode is either an octal digit or\n"))
  c.printf0(string("  contains the characters +-rwx\n"))
  c.exit(0)
{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
