'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

  ATTR_DIRECTORY = %10000
  ATTR_EXECUTE   = %100000
  ATTR_READ_ONLY = %1

OBJ
  c : "clibsd"
  g : "glob"
  r : "resolve"

DAT
  globdata long 0
  count    long 0
  str      long 0[25]

PUB main | argc, argv, argi, num, infile, outfile, buf[25], path, attrib, target, attrib1, fname
  c.enter

  if argc < 3
    c.printf0(string("usage: cp file1 [file2 ...] path\n"))
    c.exit(6)
  path := long[argv][argc-1]

  ' Get the destination file attribute
  if g.iswild(path)
    c.printf1(string("%s contains wildcard characters\n"), path)
    c.exit(1)
  r.resolve_path(path, @str)
  if strcomp(@str, string("/"))
    attrib := ATTR_DIRECTORY
  else
    attrib := c.getmod(path)
  if attrib == -1
    attrib := 0

  if attrib & ATTR_READ_ONLY
    c.printf1(string("%s is read only\n"), path)
    c.exit(1)
  attrib &= ATTR_DIRECTORY
  if attrib == 0 and (argc > 3 or g.iswild(long[argv][1]))
    c.printf1(string("%s is not a directory\n"), path)
    c.exit(2)

  target := @buf
  repeat argi from 1 to argc-2
    globdata := 0
    repeat while (fname := g.glob(long[argv][argi], @globdata, @str))
      if count++ and not attrib
        c.printf1(string("%s is not a directory\n"), path)
        g.exit(@globdata)
      infile := c.fopen(fname, string("r"))
      ifnot infile
        c.printf1(string("Could not open input file %s\n"), fname)
        g.exit(@globdata)
      attrib1 := c.getmod(fname)
      if attrib1 & ATTR_DIRECTORY
        c.printf1(string("%s is a directory\n"), fname)
        c.fclose(infile)
        next
      c.strcpy(target, path)
      if attrib
        c.strcat(target, string("/"))
        c.strcat(target, GetFileName(fname))
      outfile := c.fopen(target, string("w"))
      ifnot outfile
        c.printf1(string("Could not open output file %s\n"), target)
        c.fclose(infile)
        c.exit(5)
      c.chmod(target, attrib1)
      repeat while (num := c.fread(@buf, 1, 100, infile)) > 0
        c.fwrite(@buf, 1, num, outfile)
      c.fclose(infile)
      c.fclose(outfile)

  c.exit(0)

PRI GetFileName(path) | len
  len := strsize(path)
  if len =< 0
    return path
  path += len

  repeat while len--
    if byte[--path] == "/"
      return path + 1

  return path

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
