'******************************************************************************
' Copyright (c) 2013, Dave Hein
' See end of file for terms of use.
'******************************************************************************

CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  ut : "unixtime"
  c : "clibsd"
  sys : "sysdefs"

con
  CYCLE0   = sys#cycle0
  SECONDS  = sys#unixtime
  TIMEZONE = sys#timezone

  UNIX_SPEC = 0
  HHMM_SPEC = 1
  TIME_SPEC = 2
  DATE_SPEC = 3

pub main(argc, argv) | unixtime, date, time, hour, minute, second, year, month, day, cycle, temp, tz
  c.enter
  tz := long[TIMEZONE]
  if argc == 1
    unixtime := long[SECONDS]
    date := ut.date(unixtime, tz)
    time := ut.time(unixtime, tz)
    year   := word[@date][1]
    month  := byte[@date][1]
    day    := byte[@date][0]
    hour   := word[@time][1]
    minute := byte[@time][1]
    second := byte[@time][0]
    c.printf3(string("%2.2d/%2.2d/%2.2d "), year, month, day)
    c.printf3(string("%2.2d:%2.2d:%2.2d\n"),hour, minute, second)
    c.exit(0)

  if argc == 2 and strcomp(long[argv][1], string("-s"))
    c.printf1(string("%d\n"), long[SECONDS])
    c.exit(0)

  if (argc == 3 or argc == 4) and strcomp(long[argv][1], string("-s"))
    result := CheckString(long[argv][2])
    if result == UNIX_SPEC
      if argc == 4
        usage
      c.sscanf1(long[argv][2], string("%d"), @unixtime)
      cycle := cnt
    else
      if result == DATE_SPEC
        c.sscanf3(long[argv][2], string("%d %d %d"), @year, @month, @day)
      elseif result == TIME_SPEC
        c.sscanf3(long[argv][2], string("%d %d %d"), @hour, @minute, @second)
      else
        c.sscanf2(long[argv][2], string("%d %d"), @hour, @minute)
        second := 0
      if argc == 4
        temp := CheckString(long[argv][3])
        if temp == UNIX_SPEC or temp == result
          usage
        if temp == DATE_SPEC
          c.sscanf3(long[argv][3], string("%d %d %d"), @year, @month, @day)
          cycle := long[CYCLE0]
        elseif temp == TIME_SPEC
          c.sscanf3(long[argv][3], string("%d %d %d"), @hour, @minute, @second)
          cycle := cnt
        else
          c.sscanf2(long[argv][3], string("%d %d"), @hour, @minute)
          second := 0
          cycle := cnt
      else
        unixtime := long[SECONDS]
        if result == DATE_SPEC
          time := ut.time(unixtime, tz)
          hour   := word[@time][1]
          minute := byte[@time][1]
          second := byte[@time][0]
        else
          date := ut.date(unixtime, tz)
          year   := word[@date][1]
          month  := byte[@date][1]
          day    := byte[@date][0]
        cycle := cnt
      unixtime := ut.unix_time(year, month, day, hour, minute, second, tz)
    long[CYCLE0] := cycle
    long[SECONDS] := unixtime
    save_sysparm
    c.exit(0)

  usage
  c.exit(0)

pub CheckString(str) | slashcnt, coloncnt
  slashcnt := 0
  coloncnt := 0
  repeat while byte[str]
    if byte[str] == "/"
      slashcnt++
    elseif byte[str] == ":"
      coloncnt++
    str++
  if slashcnt == 2 and coloncnt == 0
    result := DATE_SPEC
  elseif slashcnt == 0 and coloncnt == 1
    result := HHMM_SPEC
  elseif slashcnt == 0 and coloncnt == 2
    result := TIME_SPEC
  elseif slashcnt == 0 and coloncnt == 0
    result := UNIX_SPEC
  else
    usage

pub usage
  c.printf0(string("usage: date [-s [yyyy/mm/dd] [hh:mm[:ss]]]\n"))
  c.exit(1)

pub save_sysparm | outfile, ptr
  outfile := c.fopen(string("/_sysparm"), string("w"))
  ifnot outfile
    c.printf0(string("Can't open /_sysparm\n"))
    return
  c.fprintf1(outfile, string("%d\n"), long[sys#unixtime])
  c.fprintf2(outfile, string("%d %d 0\n"), long[sys#timezone], long[sys#config])
  c.fprintf0(outfile, string("0 0 0\n"))
  c.fprintf0(outfile, string("GPWD /\n"))
  c.fprintf0(outfile, string("LSCRIPT_FILE /bin/_shellrc\n"))
  c.fprintf0(outfile, string("P# 0\n"))
  c.fclose(outfile)

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
