'**********************************************
'* Spin code generated by cspin version 0.066 *
'**********************************************

CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c : "clibsd"

PUB start(argc, argv)
  c.enter
  main(argc, argv)

'******************************************************************************
' ED Text Editor
' Copyright (c) 2011, Dave Hein
' See end of file for terms of use.
'******************************************************************************

CON
  HDR_SIZE = 8
' typedef struct StringS
next_0 = 0
size = 4
str = 8
'#define EX_MODE
  UNSPECIFIED = - 2
  PARSING_ERROR = - 3
  TAB_CHAR = 9
  MAX_CHARS = 200
' Uninitialized global variables

VAR
  long memorysize
  long ListHead
  long YankHead
  byte srchstr[100]
  byte rplcstr1[100]
  byte rplcstr2[100]
  byte filename[100]
  byte inbuf[MAX_CHARS]
' Initialized global variables

DAT
  rflag long 0
  gflag long 0
  vmode long 1
  prompt long 0
  vlines long 21
  scroll long 20
  changed long 0
  numlines long 0
  currline long 0
  currcol long 1
' Main program entry

PUB main(argc, argv) | cmd, retcode, strbuf
  'argc := 1
  ' Initialization
  srchstr[0] := 0
  rplcstr1[0] := 0
  rplcstr2[0] := 0
  ListHead := 0
  YankHead := 0
  result := c.malloc(600)
  ' Allocate the string buffer
  memorysize := 16000
  repeat while (memorysize > 0)
    strbuf := c.malloc(memorysize)
    if (strbuf)
      quit
    memorysize -= 1000
  c.free(result)
  'c.printf1(string("memorysize = %d\n"), memorysize)
  'c.printf0(string("Press any key\n"))
  'c.getchar
  smallocinit(strbuf, memorysize)
  ' Copy the input file name if specified
  if (argc > 1)
    c.strcpy(@filename, long[argv][1])
  else
    filename[0] := 0
  currline := ReadFile(@filename, 0)
  ' Get a command and execute it
  repeat while (1)
    gflag := 0
    CheckMemory
    if (vmode)
      PrintScreen(currline)
    if (prompt)
      c.printf1(string("%c"), prompt)
    c.gets(@inbuf)
    retcode := ExecuteCommand
    if (retcode > 0)
      quit
    elseif (retcode < 0)
      c.printf0(string("?\n"))
  c.free(strbuf)
  c.exit(0)
' Allocate a string link and copy contents of "str"

PUB AllocateString(str_0) | link
  link := smalloc(strsize(str_0) + 1)
  if (link)
    c.strcpy((link + str), str_0)
  return link
' Duplicate a string link

PUB DuplicateString(link)
  return AllocateString((link + str))
' Check for a memory leak

PUB CheckMemory | total, curr, listsize, yanksize, freesize
  listsize := 0
  yanksize := 0
  freesize := 0
  curr := ListHead
  repeat while (curr)
    listsize += long[curr + size]
    curr := long[curr + next_0]
  curr := YankHead
  repeat while (curr)
    yanksize += long[curr + size]
    curr := long[curr + next_0]
  curr := smfreelist
  repeat while (curr)
    freesize += long[curr + size]
    curr := long[curr + next_0]
  total := listsize + yanksize + freesize
  if (total <> memorysize)
    c.printf0(string("Memory leak!\n"))
    c.printf4(string("listsize = %d, yanksize = %d, freesize = %d, total = %d\n"), listsize, yanksize, freesize, listsize + yanksize + freesize)
' Get a pointer to a string link from its line number

PUB GetLinePtr(linenum, pprev) | prev, curr
  prev := 0
  curr := ListHead
  repeat while (curr and--linenum > 0)
    prev := curr
    curr := long[curr + next_0]
  long[pprev] := prev
  return curr
' Remove the CR and LF characters from the end of a line

PUB RemoveCRLF(str_0) | len
  len := strsize(str_0)
  str_0 += len - 1
  repeat while (len > 0)
    if (byte[str_0] <> 10 and byte[str_0] <> 13)
      quit
    byte[str_0--] := 0
    len--
' Insert a string link at the line given by "linenum"

PUB InsertLine(line, linenum) | prev, curr
  curr := GetLinePtr(linenum - 1, @prev)
  if (linenum < 1 or linenum > numlines + 1)
    c.printf2(string("InsertLine: linenum = %d, numlines = %d\n"), linenum, numlines)
  if (curr == 0 and(linenum <> 1 or ListHead <> 0))
    c.printf1(string("InsertLine: curr == 0, linenum = %d\n"), linenum)
  if (linenum == 1)
    long[line + next_0] := ListHead
    ListHead := line
  else
    long[line + next_0] := long[curr + next_0]
    long[curr + next_0] := line
  numlines++
' Delete the line at "linenum"

PUB DeleteLine(linenum) | prev, curr
  curr := GetLinePtr(linenum, @prev)
  if (not curr)
    c.printf1(string("DeleteLine: curr = 0, linenum = %d\n"), linenum)
    return
  if (not prev)
    ListHead := long[curr + next_0]
  else
    long[prev + next_0] := long[curr + next_0]
  sfree(curr)
  numlines--
' Based on the value of gflag, check for if the line
' at "lineptr" does, or does not contains "str"

PUB CheckMatch(lineptr, str_0)
  if (gflag == 0)
    return 0
  if (gflag == 1)
    if (not FindString(lineptr, str_0))
      return 1
    return 0
  if (FindString(lineptr, str_0))
    return 1
  return 0
' Print lines using the "n", "v", "l" or "p" format

PUB PrintLines(linenum, first, last, mode) | col, len, line, fflag, lastproc, LinePtr_0, prev, curr
  lastproc := linenum
  curr := GetLinePtr(first, @prev)
  line := first
  repeat while (line =< last)
    if (not curr)
      c.printf1(string("PrintLines: curr = 0, line = %s\n"), line)
      return 0
    LinePtr_0 :=(curr + str)
    curr := long[curr + next_0]
    if (CheckMatch(LinePtr_0, @srchstr))
      line++
      next
    if (mode == "n")
      c.printf2(string("%6d  %s\n"), line, LinePtr_0)
    elseif (mode == "v")
      if (line == linenum)
        c.printf2(string("%6d >%s\n"), line, LinePtr_0)
      else
        c.printf2(string("%6d  %s\n"), line, LinePtr_0)
    elseif (mode == "l")
      repeat while (byte[LinePtr_0])
        if (byte[LinePtr_0] => 32 and byte[LinePtr_0] < 127)
          c.printf1(string("%c"), byte[LinePtr_0])
        elseif (byte[LinePtr_0] == TAB_CHAR)
          c.printf0(string("\\t"))
        else
          c.printf1(string("\\x%2.2x"), byte[LinePtr_0])
        LinePtr_0++
      c.printf0(string("$\n"))
    else
      c.printf1(string("%s\n"), LinePtr_0)
    lastproc := line
    line++
  return lastproc
' Decode a number from the string

PUB getnum(pstr) | val, str_0
  val := 0
  str_0 := long[pstr]
  repeat while (c.isdigit(byte[str_0]))
    val :=(val * 10) + byte[str_0++] - "0"
  long[pstr] := str_0
  return val
' Find the next character that matches "val"

PUB FindChar(str_0, val)
  repeat while (byte[str_0])
    if (byte[str_0] == val)
      quit
    str_0++
  return str_0
' Skip the next character that does not match "val"

PUB SkipChar(str_0, val)
  repeat while (byte[str_0])
    if (byte[str_0] <> val)
      quit
    str_0++
  return str_0
' Return true if "str2" is found in "str1"

PUB FindString(str1, str2) | len
  len := strsize(str2)
  repeat while (byte[str1])
    if (c.strncmp(str1, str2, len) == 0)
      return 1
    str1++
  return 0
' Use the first character as a delimeter and copy the string to srchstr

PUB GetString(pstr) | ptr, str_0, val, len
  str_0 := long[pstr]
  val := byte[str_0++]
  if (not val)
    return 0
  ptr := FindChar(str_0, val)
  len :=(ptr) -(str_0)
  if (byte[ptr])
    ptr++
  long[pstr] := ptr
  if (len > 0)
    c.memcpy(@srchstr, str_0, len)
    srchstr[len] := 0
  return 1
' Search forward through all the lines for the first occurance of srchstr

PUB SearchStringForward(pstr, linenum) | i, prev, curr
  curr := GetLinePtr(linenum + 1, @prev)
  if (not GetString(pstr))
    return PARSING_ERROR
  i := linenum + 1
  repeat while (i =< numlines)
    if (not curr)
      c.printf1(string("SearchStringForward: curr = 0, line = %d\n"), i)
      return - 3
    if (FindString((curr + str), @srchstr))
      return i
    curr := long[curr + next_0]
    i++
  curr := ListHead
  i := 1
  repeat while (i =< linenum)
    if (not curr)
      c.printf1(string("SearchStringForward: curr = 0, line = %d\n"), i)
      return - 3
    if (FindString((curr + str), @srchstr))
      return i
    curr := long[curr + next_0]
    i++
  return PARSING_ERROR
' Search backward through all the lines for the first occurance of srchstr
' Note: This is not as efficient as the forward seach because we must use
' GetLinePtr to get the string link pointer

PUB SearchStringBackward(pstr, linenum) | i, prev, curr
  if (not GetString(pstr))
    return PARSING_ERROR
  i := linenum - 1
  repeat while (i => 1)
    curr := GetLinePtr(i, @prev)
    if (not curr)
      c.printf1(string("SearchStringBackward: curr = 0, line = %d\n"), i)
      return - 3
    if (FindString((curr + str), @srchstr))
      return i
    i--
  i := numlines
  repeat while (i => linenum)
    curr := GetLinePtr(i, @prev)
    if (not curr)
      c.printf1(string("SearchStringBackward: curr = 0, line = %d\n"), i)
      return - 3
    if (FindString((curr + str), @srchstr))
      return i
    i--
  return PARSING_ERROR
' Parse the replace string command and extract rplcstr1 and rplcstr2

PUB ParseReplaceString(str_0) | ptr
  if (byte[str_0++] <> "s")
    return 0
  if (byte[str_0] == 0)
    return 1
  if (byte[str_0++] <> "/")
    return 0
  ptr := FindChar(str_0, "/")
  if (byte[ptr] <> "/")
    return 0
  byte[ptr++] := 0
  if (byte[str_0])
    c.strcpy(@rplcstr1, str_0)
  else
    c.strcpy(@rplcstr1, @srchstr)
  if (byte[ptr] == 0)
    return 1
  str_0 := FindChar(ptr, "/")
  if (byte[str_0] <> "/")
    return 0
  byte[str_0++] := 0
  c.strcpy(@rplcstr2, ptr)
  rflag :=(byte[str_0] == "g")
  return 1
' Store the results of the replace-string command on str1 into str2

PUB ReplaceString(str1, str2) | changeflag, len1, len2
  changeflag := 0
  len1 := strsize(@rplcstr1)
  len2 := strsize(@rplcstr2)
  ' Search through str1 for rplcstr1 and replace with rplcstr2
  repeat while (byte[str1])
    if (c.strncmp(str1, @rplcstr1, len1) == 0)
      changeflag := 1
      c.memcpy(str2, @rplcstr2, len2)
      str2 += len2
      str1 += len1
      ' Quit after the first time if 'g' was not specified
      if (not rflag)
        quit
    else
      byte[str2++] := byte[str1++]
  ' Copy the remainder of str1 to str2
  repeat while (byte[str1])
    byte[str2++] := byte[str1++]
  byte[str2] := 0
  return changeflag
' Execute the replace-string command on multiple lines in the text buffer

PUB ReplaceStringCommand(inptr, first, last, linenum) | i, lastproc, changeflag, link, prev, curr
  lastproc := linenum
  changeflag := 0
  curr := GetLinePtr(first, @prev)
  if (not ParseReplaceString(inptr))
    c.printf0(string("?\n"))
    return last
  i := first
  repeat while (i =< last)
    if (not curr)
      c.printf1(string("ReplaceStringCommand: line = %d\n"), i)
      return 1
    if (CheckMatch((curr + str), @srchstr))
      prev := curr
      curr := long[curr + next_0]
      i++
      next
    if (ReplaceString((curr + str), @inbuf))
      link := curr
      curr := smalloc(strsize(@inbuf) + 1)
      if (not curr)
        return lastproc
      c.strcpy((curr + str), @inbuf)
      if (prev)
        long[prev + next_0] := curr
      else
        ListHead := curr
      long[curr + next_0] := long[link + next_0]
      sfree(link)
      changeflag := 1
      changed := 1
    prev := curr
    curr := long[curr + next_0]
    lastproc := i
    i++
  if (not changeflag)
    c.printf0(string("?\n"))
  return lastproc
' Extract a line number parameter from a command

PUB GetLineNumber(str_0, linenum, num) | val
  if (byte[str_0][0] == ".")
    long[num] := linenum
    str_0++
  elseif (byte[str_0][0] == "-")
    str_0++
    if (c.isdigit(byte[str_0]))
      val := getnum(@str_0)
    else
      val := 1
    long[num] := linenum - val
  elseif (byte[str_0][0] == "+")
    str_0++
    if (c.isdigit(byte[str_0]))
      val := getnum(@str_0)
    else
      val := 1
    long[num] := linenum + val
  elseif (byte[str_0][0] == "$")
    long[num] := numlines
    str_0++
  elseif (byte[str_0][0] == "/")
    long[num] := SearchStringForward(@str_0, linenum)
  elseif (byte[str_0][0] == "?")
    long[num] := SearchStringBackward(@str_0, linenum)
  elseif (c.isdigit(byte[str_0]))
    long[num] := getnum(@str_0)
  else
    long[num] := UNSPECIFIED
  if (long[num] <> UNSPECIFIED and(long[num] < 0 or long[num] > numlines))
    long[num] := PARSING_ERROR
  return str_0
' Extract the first and last numbers and the command from a command string

PUB ParseCommand(pstr, linenum, first, last, cmd, bang) | done, str_0
  done := 0
  str_0 := long[pstr]
  long[bang] := 0
  if (byte[str_0] == ",")
    long[first] := 1
    long[last] := numlines
    done := 1
  elseif (byte[str_0] == ";")
    long[first] := linenum
    long[last] := numlines
    done := 1
  if (done)
    str_0++
    long[cmd] := byte[str_0]
    if (byte[str_0] and byte[str_0][1] == "!")
      long[bang] := 1
      str_0++
    long[pstr] := str_0
    return 1
  str_0 := GetLineNumber(str_0, linenum, first)
  if (long[first] == PARSING_ERROR)
    return 0
  if (long[first] == UNSPECIFIED)
    if (numlines == 0 and byte[str_0] == "i")
      long[first] := long[last] := 1
    elseif (byte[str_0] == "g" or byte[str_0] == "v" or byte[str_0] == "w" or byte[str_0] == "x")
      long[first] := 1
      long[last] := numlines
    elseif (byte[str_0] == "j")
      long[first] := linenum
      long[last] := linenum + 1
      if (long[last] > numlines)
        return 0
    elseif (byte[str_0] == "r")
      long[first] := numlines
      long[last] := numlines
    elseif (byte[str_0] == 0 or byte[str_0] == "z")
      long[first] := long[last] := linenum + 1
      if (long[first] > numlines)
        return 0
    elseif (byte[str_0] == "=")
      long[first] := long[last] := numlines
    else
      long[first] := linenum
      long[last] := linenum
  elseif (byte[str_0] == "," or byte[str_0] == ";")
    str_0 := GetLineNumber(str_0 + 1, linenum, last)
    if (long[last] == PARSING_ERROR)
      return 0
    if (long[last] == UNSPECIFIED)
      long[last] := long[first]
    if (long[last] <(long[first]))
      return 0
  else
    long[last] := long[first]
  long[cmd] := byte[str_0]
  if (byte[str_0] and byte[str_0][1] == "!")
    long[bang] := 1
    str_0++
  long[pstr] := str_0
  ' If first is zero, check if commands allows that
  if (long[first] == 0)
    str_0 := FindChar(string("aq=EerxQhVfP"), long[cmd])
    if (byte[str_0] == 0)
      return 0
  return 1
' Print the help information

PUB help | infile, line, char, buffer[25]
  infile := c.fopen(string("/manpages/edhelp.txt"), string("r"))
  ifnot infile
    return
  line := 0
  repeat while c.fgets(@buffer, 100, infile)
    RemoveCRLF(@buffer)
    c.printf1(string("%s\n"), @buffer)
    if ++line => vlines + 2
      c.printf0(string("<more>"))
      char := c.getchar
      c.printf0(string("\b\b\b\b\b\b      \b\b\b\b\b\b"))
      if char == "q" OR char == 3
        quit
      elseif char == 13
        line--
      else
        line := 0
  if ++line
    c.printf0(string("<more>"))
    char := c.getchar
    c.printf0(string("\b\b\b\b\b\b      \b\b\b\b\b\b"))
  c.fclose(infile)

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}

' Print a visualization mode screen

PUB PrintScreen(linenum) | i, vlines1, vlines2, first, last
  vlines1 := vlines - 1
  vlines2 := vlines / 2
  first := linenum - vlines2
  last := first + vlines1
  ' Determine the first and last lines to display
  if (first < 1)
    first := 1
    last := first + vlines1
    if (last > numlines)
      last := numlines
  elseif (last > numlines)
    last := numlines
    first := last - vlines1
    if (first < 1)
      first := 1
  c.printf0(string("===============================================================\n"))
  PrintLines(linenum, first, last, "v")
  i := last - first
  repeat while (i < vlines1)
    c.printf0(string("~\n"))
    i++
  c.printf0(string("===============================================================\n"))
' Empty a list and free the string links

PUB EmptyList(list) | next_1
  repeat while (list)
    next_1 := long[list + next_0]
    sfree(list)
    list := next_1
' Delete lines from the text file list and move them to the yank list

PUB DeleteLines(first, last) | i, prev, curr, yank
  curr := GetLinePtr(first, @prev)
  yank := 0
  EmptyList(YankHead)
  YankHead := 0
  i := first
  repeat while (i =< last)
    if (not curr)
      c.printf1(string("DeleteLines: line = %d\n"), first)
      return 1
    if (not yank)
      YankHead := curr
    else
      long[yank + next_0] := curr
    yank := curr
    curr := long[curr + next_0]
    numlines--
    i++
  if (prev)
    long[prev + next_0] := curr
  else
    ListHead := curr
  long[yank + next_0] := 0
  changed := 1
  if (first > numlines)
    first := numlines
  return first
' Copy lines from the text file list to the yank list

PUB YankLines(first, last) | line, link, list, curr
  list := 0
  curr := GetLinePtr(first, @link)
  EmptyList(YankHead)
  YankHead := 0
  line := first
  repeat while (line =< last)
    if (not curr)
      c.printf1(string("YankLines: line = %d\n"), line)
      return 1
    link := DuplicateString(curr)
    if (not link)
      quit
    if (not list)
      YankHead := link
    else
      long[list + next_0] := link
    curr := long[curr + next_0]
    list := link
    line++
  if (list)
    long[list + next_0] := 0
  return last
' Copy the lines on the yank list to the text file list

PUB PushLines(line) | link, curr
  curr := YankHead
  repeat while (curr)
    link := DuplicateString(curr)
    if (not link)
      quit
    InsertLine(link,++line)
    curr := long[curr + next_0]
    changed := 1
  return line
' Go into the text input mode and append after "linenum"

PUB AppendLines(linenum) | prev, curr, link
  curr := GetLinePtr(linenum + 1, @prev)
  repeat while (1)
    c.gets(@inbuf)
    RemoveCRLF(@inbuf)
    if (inbuf[0] == "." and inbuf[1] == 0)
      quit
    link := AllocateString(@inbuf)
    if (not link)
      quit
    long[link + next_0] := curr
    if (prev)
      long[prev + next_0] := link
    else
      ListHead := link
    prev := link
    linenum++
    numlines++
    changed := 1
  return linenum
' Go into the text input mode and insert lines before "linenum"

PUB InsertLines(linenum) | linenum1
  linenum1 := AppendLines(linenum - 1)
  if (linenum1 > linenum)
    linenum := linenum1
  return linenum
' Join lines together and move the original lines to the yank buffer

PUB JoinLines(first, last) | i, len, str_0, prev, curr, link, yank
  len := 0
  curr := GetLinePtr(first, @prev)
  link := curr
  yank := 0
  EmptyList(YankHead)
  YankHead := 0
  ' Determine the total length of the selected lines
  i := first
  repeat while (i =< last)
    if (not link)
      c.printf1(string("JoinLines: line = %d\n"), i)
      return 1
    len += strsize((link + str))
    link := long[link + next_0]
    i++
  ' Allocate a new string buffer and concatenate the strings
  link := smalloc(len + 1)
  if (not link)
    return first
  str_0 :=(link + str)
  byte[str_0] := 0
  i := first
  repeat while (i =< last)
    if (not curr)
      c.printf1(string("JoinLines: line = %d\n"), i)
      return 1
    c.strcat(str_0,(curr + str))
    if (not yank)
      YankHead := curr
    else
      long[yank + next_0] := curr
    yank := curr
    curr := long[curr + next_0]
    numlines--
    changed := 1
    i++
  ' Insert the new string
  if (prev)
    long[prev + next_0] := link
  else
    ListHead := link
  long[link + next_0] := curr
  long[yank + next_0] := 0
  numlines++
  return first
' Move or copy lines to after the destination address

PUB MoveLines(first, last, dstaddr, cmd) | i, prev, curr, link, srcaddr, insertbefore
  if (dstaddr < 0 or dstaddr > numlines or(first =< dstaddr and dstaddr < last))
    c.printf0(string("?\n"))
  else
    srcaddr := first
    insertbefore := dstaddr < first
    i := first
    repeat while (i =< last)
      curr := GetLinePtr(srcaddr++, @prev)
      link := DuplicateString(curr)
      if (not link)
        quit
      InsertLine(link,++dstaddr)
      if (insertbefore)
        srcaddr++
      if (cmd == "m")
        DeleteLine(--srcaddr)
        if (not insertbefore)
          dstaddr--
      i++
    changed := 1
  return dstaddr
' Read a file after "linenum"

PUB ReadFile(fname, linenum) | numchar, infile, link
  numchar := 0
  infile := c.fopen(fname, string("r"))
  if (infile)
    repeat while (c.fgets(@inbuf, MAX_CHARS, infile))
      RemoveCRLF(@inbuf)
      link := AllocateString(@inbuf)
      if (not link)
        quit
      InsertLine(link,++linenum)
      numchar += strsize(@inbuf)
    c.fclose(infile)
  c.printf1(string("%d\n"), numchar)
  return linenum
' Write lines first to last to the output file

PUB WriteFile(fname, first, last) | i, LinePtr_0, curr, prev, numchar, outfile
  numchar := 0
  outfile := c.fopen(fname, string("w"))
  if (not outfile)
    return - 1
  i := first
  repeat while (i =< last)
    curr := GetLinePtr(i, @prev)
    LinePtr_0 :=(curr + str)
    numchar += strsize(LinePtr_0)
    c.fprintf1(outfile, string("%s\n"), LinePtr_0)
    i++
  c.fclose(outfile)
  c.printf1(string("%d\n"), numchar)
  if (first == 1 and last == numlines)
    changed := 0
  return 0
' Execute a command

PUB ExecuteCommand | curr, prev, LinePtr_0, outfile, inptr, first, last, cmd, i, temp, numchar, bang
  inptr := @inbuf
  ' Parse the command and extract the parameters
  if (not ParseCommand(@inptr, currline, @first, @last, @cmd, @bang))
    return - 2
  ' Parse a "g" or "v" command if present
  if (cmd == "g" or cmd == "v")
    inptr++
    if (GetString(@inptr))
      if (cmd == "g")
        gflag := 1
      else
        gflag := 2
      cmd := byte[inptr]
      if (cmd == 0)
        cmd := "p"
      c.printf1(string("cmd = %c\n"), cmd)
    else
      return - 3
  ' Select the command and execute it
  case(cmd)
    0 :
      ' Print the current line if no command
      if (numlines == 0)
        return - 4
      if (last => 0)
        currline := last
      elseif (first => 0)
        currline := first
      curr := GetLinePtr(currline, @prev)
      LinePtr_0 :=(curr + str)
      c.printf1(string("%s\n"), LinePtr_0)
    "Q" :
      ' Quit unconditionally
      return 1
    "q" :
      ' Check for changes and quit if OK
      if (changed == 0)
        return 1
      changed := 0
      return - 5
    "e", "E" :
      ' Reset the text buffer to the contents of the default file
      if (changed and cmd == "e")
        changed := 0
        return - 6
      inptr := SkipChar(inptr + 1, " ")
      if (byte[inptr] == 0 and filename == 0)
        return - 7
      if (byte[inptr])
        c.strcpy(@filename, inptr)
      EmptyList(YankHead)
      YankHead := 0
      EmptyList(ListHead)
      ListHead := 0
      numlines := 0
      currline := ReadFile(@filename, 0)
      changed := 0
    "r" :
      ' Read the contents of a file after the specified line
      inptr := SkipChar(inptr + 1, " ")
      if (byte[inptr] == 0 and filename == 0)
        return - 8
      if (byte[inptr])
        if (not filename[0])
          c.strcpy(@filename, inptr)
      else
        inptr := @filename
      temp := numlines
      currline := ReadFile(inptr, first)
      if (temp and numlines <> temp)
        changed := 1
    "w" :
      ' Write the text buffer to a file
      inptr := SkipChar(inptr + 1, " ")
      if (byte[inptr] == 0)
        if (filename == 0)
          return - 9
        inptr := @filename
      if (WriteFile(inptr, first, last) < 0)
        return - 10
      if (cmd == "x")
        return 1
      if (filename == 0)
        c.strcpy(@filename, inptr)
    "d" :
      ' Delete the specified lines
      currline := DeleteLines(first, last)
    "m", "t" :
      ' Move or copy the specified lines
      if (byte[inptr][1])
        c.sscanf1(inptr + 1, string("%d"), @temp)
      else
        temp := currline
      currline := MoveLines(first, last, temp, cmd)
    "c" :
      ' Change the specified lines
      temp :=(last == numlines)
      currline := DeleteLines(first, last)
      if (temp)
        currline := AppendLines(currline)
      else
        currline := InsertLines(currline)
    "a" :
      ' Append text after the specified line
      currline := AppendLines(first)
    "i" :
      ' Insert text before the specified line
      currline := InsertLines(first)
    "j" :
      ' Join together lines
      currline := JoinLines(first, last)
    "p", "l", "n" :
      ' Print lines in either the "p", "l" or "n" format
      currline := PrintLines(currline, first, last, cmd)
    "h" :
      ' Print help information
      help
    "V" :
      ' Set the number of lines in the visualization mode or
      ' toggle the visualization mode if no lines are specified
      if (byte[inptr][1])
        c.sscanf1(inptr + 1, string("%d"), @temp)
        if (temp =< 0)
          return - 11
        vlines := temp
        vmode := 1
      else
        vmode := vmode ^ 1
    "s" :
      ' Replace text in the specified lines
      currline := ReplaceStringCommand(inptr, first, last, currline)
    "x" :
      ' Push text from the yank buffer
      currline := PushLines(first)
    "y" :
      ' Yank lines to the yank buffer
      currline := YankLines(first, last)
    "z" :
      ' Set the number of lines to scroll if specified,
      ' and scroll forward
      first := last
      if (byte[inptr][1])
        c.sscanf1(inptr + 1, string("%d"), @temp)
        if (temp =< 0)
          return - 12
        scroll := temp
      last := first + scroll
      if (last > numlines)
        last := numlines
      PrintLines(currline, first, last, "p")
      currline := last
    "f" :
      ' Set the default file name if specifed and print it
      inptr := SkipChar(inptr + 1, " ")
      if (byte[inptr] == 0 and filename == 0)
        return - 13
      if (byte[inptr])
        c.strcpy(@filename, inptr)
      c.printf1(string("%s\n"), @filename)
    "=" :
      ' Print the number of lines, or the line number if specified
      c.printf1(string("%d\n"), last)
    "P" :
      ' Toggle the prompt mode
      if (prompt)
        prompt := 0
      else
        prompt := "*"
    OTHER :
      ' Return error code if not a valid command
      return - 14
  return 0
'******************************************************************************
' String Allocation Routines
' Copyright (c) 2011, Dave Hein
' See end of file for terms of use.
'******************************************************************************

VAR
  long smfreelist

PUB smallocinit(ptr, size_0) | curr
  curr := ptr
  smfreelist := curr
  long[curr + next_0] := 0
  long[curr + size] := size_0
' Allocate a block of "size" bytes.  Return a pointer to the block if
' successful, or zero if a large enough memory block could not be found

PUB smalloc(size_0) | prev, curr, next_1
  'printf("smalloc: %d\n", size);
  if (size_0 =< 0)
    return 0
  ' Adjust size to nearest long plus the header size
  size_0 :=((size_0 + 3) &(! 3)) + HDR_SIZE
  ' Search for a block of memory
  prev := 0
  curr := smfreelist
  repeat while (curr)
    if (long[curr + size] => size_0)
      quit
    prev := curr
    curr := long[curr + next_0]
  ' Return null if block not found
  if (curr == 0)
    c.printf0(string("Out of memory!\n"))
    return 0
  ' Get next pointer
  next_1 := long[curr + next_0]
  ' Split block if larger than needed
  if (long[curr + size] => size_0 + HDR_SIZE + 16)
    next_1 :=(((curr) + size_0))
    long[next_1 + next_0] := long[curr + next_0]
    long[next_1 + size] := long[curr + size] - size_0
    long[curr + next_0] := next_1
    long[curr + size] := size_0
  ' Remove block from the free list
  long[curr + next_0] := 0
  if (prev)
    long[prev + next_0] := next_1
  else
    smfreelist := next_1
  return curr
' Insert a memory block back into the free list.  Merge blocks together if
' the memory block is contiguous with other blocks on the list.

PUB sfree(curr) | prev, next_1
  prev := 0
  next_1 := smfreelist
  ' Find Insertion Point
  repeat while (next_1)
    if (curr => prev and curr =< next_1)
      quit
    prev := next_1
    next_1 := long[next_1 + next_0]
  ' Merge with the previous block if contiguous
  if (prev and(((prev) + long[prev + size])) == curr)
    long[prev + size] += long[curr + size]
    ' Also merge with next block if contiguous
    if ((((prev) + long[prev + size])) == next_1)
      long[prev + size] += long[next_1 + size]
      long[prev + next_0] := long[next_1 + next_0]
  ' Merge with the next block if contiguous
  elseif (next_1 and(((curr) + long[curr + size])) == next_1)
    long[curr + size] += long[next_1 + size]
    long[curr + next_0] := long[next_1 + next_0]
    if (prev)
      long[prev + next_0] := curr
    else
      smfreelist := curr
  ' Insert in the middle of the free list if not contiguous
  elseif (prev)
    long[prev + next_0] := curr
    long[curr + next_0] := next_1
  ' Otherwise, insert at beginning of the free list
  else
    smfreelist := curr
    long[curr + next_0] := next_1
{
+----------------------------------------------------------------------------+
|                          TERMS OF USE: MIT License                         |
+----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy|
|of this software and associated documentation files (the "Software"), to    |
|deal in the Software without restriction, including without limitation the  |
|rights to use, copy, modify, merge, publish, distribute, sublicense, and/or |
|sell copies of the Software, and to permit persons to whom the Software is  |
|furnished to do so, subject to the following conditions:                    |
|                                                                            |
|The above copyright notice and this permission notice shall be included in  |
|all copies or substantial portions of the Software.                         |
|                                                                            |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR  |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,    |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER      |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING     |
|FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS|
|IN THE SOFTWARE.                                                            |
+----------------------------------------------------------------------------+
}
