'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

  ATTR_DIRECTORY = $10

OBJ
  c : "clibsd"
  g : "glob"

DAT
  buffer long 0[50]

PUB main(argc, argv) | i, ptr, globdata, attrib, infile, str[25]

  c.enter

  if argc < 3
    c.printf0(string("usage: grep string files...\n"))
    c.exit(1)

  repeat i from 2 to argc - 1
    globdata := 0
    repeat while (ptr := g.glob(long[argv][i], @globdata, @str))
      attrib := c.getmod(ptr)
      if attrib == -1 or (attrib & ATTR_DIRECTORY)
        next
      infile := c.fopen(ptr, string("r"))
      ifnot infile
        next
      repeat while c.fgets(@buffer, 199, infile)
        RemoveCRLF(@buffer)
        if FindString(@buffer, long[argv][1])
          if argc == 3 and not g.iswild(long[argv][i])
            c.printf1(string("%s\n"), @buffer)
          else
            c.printf2(string("%s:%s\n"), ptr, @buffer)
      c.fclose(infile)

  c.exit(0)

PUB FindString(str1, str2) | len
  len := strsize(str2)
  repeat while byte[str1]
    ifnot c.strncmp(str1, str2, len)
      return 1
    str1++

PUB RemoveCRLF(str) | len
  len := strsize(str)
  str += len - 1
  repeat while len
    if byte[str] <> 10 and byte[str] <> 13
      quit
    str--
    len--
  byte[str][1] := 0

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
