'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c : "clibsd"

DAT
  buffer byte 0[100]

PUB main(argc, argv) | num
  c.enter
  if argc > 2
    usage
  if argc < 2
    PrintAll
  elseif strcomp(long[argv][1], string("-c"))
    c.remove(string("/_history"))
  elseif isdigit(byte[long[argv][1]])
    c.sscanf1(long[argv][1], string("%d"), @num)
    PrintTail(num)
  else
    usage
  c.exit(0)

PUB usage
  c.printf0(string("usage: history [-c] [n]\n"))
  c.exit(0)

PUB isdigit(val)
  return val => "0" and val =< "9"

PUB PrintAll | i, infile
  if (infile := c.fopen(string("/_history"), string("r")))
    i := 1
    repeat while c.fgets(@buffer, 100, infile)
      c.printf2(string("%d %s"), i++, @buffer)
    c.fclose(infile)

PUB PrintTail(num) | infile, numlines, linenum, line
  if (infile := c.fopen(string("/_history"), string("r")))
    numlines := 0
    repeat while c.fgets(@buffer, 100, infile)
      numlines++
    c.fseek(infile, 0, c#SEEK_SET)
    linenum := numlines - num
    line := 1
    repeat while c.fgets(@buffer, 100, infile)
      if line > linenum
        c.printf2(string("%d %s"), line, @buffer)
      line++
    c.fclose(infile)


{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
