'******************************************************************************
' Copyright (c) 2013 Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

DAT
  nullstr long 0
  tokens long 0[25]
  buffer long 0[25]
  ops2 byte ">=", "<=", "==", "!=", "&&", "||", ">>", "<<", 0

OBJ
  c : "clibsd"
  vs : "varsubs"

PUB main(argc, argv) | i, argi, num, val, ptr, numstr[5]
  c.enter
  val := 0
  argi := 1
  repeat while argi < argc
    num := tokenize(long[argv][argi])
{
    c.printf2(string("argi = %d, num = %d: "), argi, num)
    i := 0
    repeat while i < num
      c.printf1(string(" <%s>"), tokens[i++])
    c.printf0(string("\n"))
}
    if num < 3
      argi++
      next
    ifnot strcomp(tokens[1], string("="))
      argi++
      next
    val := 0
    repeat i from 2 to num - 1
      ptr := tokens[i]
      if strcomp(ptr, string("+"))
        val += GetValue(tokens[++i])
      elseif strcomp(ptr, string("-"))
        val -= GetValue(tokens[++i])
      elseif strcomp(ptr, string("*"))
        val *= GetValue(tokens[++i])
      elseif strcomp(ptr, string("/"))
        val /= GetValue(tokens[++i])
      elseif strcomp(ptr, string("&"))
        val &= GetValue(tokens[++i])
      elseif strcomp(ptr, string("^"))
        val ^= GetValue(tokens[++i])
      elseif strcomp(ptr, string("|"))
        val |= GetValue(tokens[++i])
      elseif strcomp(ptr, string("<"))
        val := (val < GetValue(tokens[++i])) & 1
      else
        if strcomp(ptr, string(">"))
          val := (val > GetValue(tokens[++i])) & 1
        elseif strcomp(ptr, string(">="))
          val := (val >= GetValue(tokens[++i])) & 1
        elseif strcomp(ptr, string("<="))
          val := (val <= GetValue(tokens[++i])) & 1
        elseif strcomp(ptr, string("=="))
          val := (val == GetValue(tokens[++i])) & 1
        elseif strcomp(ptr, string("!="))
          val := (val <> GetValue(tokens[++i])) & 1
        elseif strcomp(ptr, string("<<"))
          val <<= GetValue(tokens[++i])
        elseif strcomp(ptr, string(">>"))
          val ~>= GetValue(tokens[++i])
        elseif strcomp(ptr, string("&&"))
          val := (val and GetValue(tokens[++i])) & 1
        elseif strcomp(ptr, string("||"))
          val := (val or GetValue(tokens[++i])) & 1
        elseif strcomp(ptr, string("%"))
          val //= GetValue(tokens[++i])
        else
          val := GetValue(tokens[i])
    c.sprintf1(@numstr, string("%d"), val)
{
    c.printf3(string("SaveVar(%s, %s, %c)\n"), tokens[0], @numstr, vs#LOCAL_FLAG)
}
    vs.SaveVar(tokens[0], @numstr, vs#LOCAL_FLAG)
    argi++
  c.exit((val == 0) & 1)

PUB GetValue(str)
  if c.isdigit(byte[str])
    result := vs.atol(str)
  else
    result := vs.atol(vs.GetVarVal(str))

PUB IsDelimeter(val) | ptr
  if val == 0
    return 1
  ptr := vs.FindChar(string(" =+-*/&^|<>%!"), val)
  if byte[ptr]
    return 1

PUB IsOperator2(ptr) | ptr2
  ptr2 := @ops2
  repeat while byte[ptr2]
    if byte[ptr] == byte[ptr2] and byte[ptr][1] == byte[ptr2][1]
      return 1
    ptr2 += 2

PUB tokenize(ptr1) | ptr2, num
  num := 0
  ptr2 := @buffer
  repeat while byte[ptr1]
    ptr1 := vs.SkipChar(ptr1, " ")
    ifnot byte[ptr1]
      quit
    tokens[num++] := ptr2
    if IsDelimeter(byte[ptr1])
      if IsOperator2(ptr1)
        byte[ptr2++] := byte[ptr1++]
      byte[ptr2++] := byte[ptr1++]
    else
      repeat until IsDelimeter(byte[ptr1])
        byte[ptr2++] := byte[ptr1++]
    byte[ptr2++] := 0
  return num

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
