'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c : "clibsd"

PUB main(argc, argv) | infile, line, char, buffer[25], maxlines
  c.enter
  if (argc <> 2)
    c.printf0(string("usage: man application\n"))
    c.exit(0)
  else
    c.strcpy(@buffer, string("/manpages/"))
    c.strcat(@buffer, long[argv][1])
    c.strcat(@buffer, string(".txt"))
    infile := c.fopen(@buffer, string("r"))
    if (infile == 0)
      c.printf1(string("No manual entry for %s\n"), long[argv][1])
      c.exit(0)

  ifnot (maxlines := (c.getconfig >> 8) & 255)
    maxlines := 24

  line := 0
  repeat while c.fgets(@buffer, 100, infile)
    RemoveCRLF(@buffer)
    c.printf1(string("%s\n"), @buffer)
    if ++line => maxlines - 1
      c.printf0(string("<more>"))
      char := c.getchar
      c.printf0(string("\b\b\b\b\b\b      \b\b\b\b\b\b"))
      if char == "q" OR char == 3
        quit
      elseif char == 13
        line--
      else
        line := 0
  c.fclose(infile)
  c.exit(0)

PUB RemoveCRLF(str) | len
  len := strsize(str)
  str += len - 1
  repeat while len
    if byte[str] <> 10 and byte[str] <> 13
      quit
    str--
    len--
  byte[str][1] := 0

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
