'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c : "clibsd"

PUB main(argc, argv) | fname, infile, mode
  c.enter
  mode := "o"
  if argc < 2 OR argc > 3
    usage
  if argc == 3
    fname := long[argv][2]
    if byte[long[argv][1]] <> "-"
      usage
    mode := byte[long[argv][1]][1]
    if mode <> "o" AND mode <> "x" AND mode <> "a"
      usage
  else
    fname := long[argv][1]
  infile := c.fopen(fname, STRING("r"))
  IF (infile == 0)
    c.printf1(STRING("File %s not found\n"), fname)
    c.exit(@@0)
  if mode == "x"
    dumphex(infile)
  elseif mode == "o"
    dumpoctal(infile)
  else
    dumpascii(infile)
  c.fclose(infile)
  c.exit(0)

PUB dumphex(infile) | num, i, j, buf[4]
  j := 0
  repeat while ((num := c.fread(@buf, 1, 16, infile)) > 0)
    c.printf1(string("%04x"), j)
    j += 16
    i := 0
    repeat while (i < num)
      c.printf1(string(" %02x"), byte[@buf][i])
      i++
    c.printf0(string("\n"))

PUB dumpoctal(infile) | num, i, j, buf[4]
  j := 0
  repeat while ((num := c.fread(@buf, 1, 16, infile)) > 0)
    c.printf1(string("%06o"), j)
    j += 16
    i := 0
    repeat while (i < num)
      c.printf1(string(" %03o"), byte[@buf][i])
      i++
    c.printf0(string("\n"))

PUB dumpascii(infile) | num, i, j, buf[4], char
  j := 0
  repeat while ((num := c.fread(@buf, 1, 16, infile)) > 0)
    c.printf1(string("%04x"), j)
    j += 16
    i := 0
    repeat while (i < num)
      char := byte[@buf][i]
      if char => 32 AND char =< 126
        c.printf1(string("  %c"), char)
      elseif char == 9
        c.printf0(string(" \\t"))
      elseif char == 10
        c.printf0(string(" \\n"))
      elseif char == 13
        c.printf0(string(" \\r"))
      else
        c.printf1(string(" %02x"), char)
      i++
    c.printf0(string("\n"))

PUB usage
  c.printf0(string("usage: od [flags] filename\n"))
  c.printf0(string("  -o Dump in octal (default)\n"))
  c.printf0(string("  -x Dump in hex\n"))
  c.printf0(string("  -a Dump in ASCII\n"))
  c.exit(0)

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
