'******************************************************************************
' Copyright (c) 2013 Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

  DOUBLE_QUOTE = $22
  GLOBAL_FLAG = "G"

OBJ
  c : "clibsd"
  sys : "sysdefs"

PUB main(argc, argv) | ptr, argi
  c.enter

  if argc == 1
    PrintVars
    c.exit(0)

  argi := 1
  repeat while argi < argc
    if (ptr := FindVar(long[argv][argi++]))
      if byte[ptr] == GLOBAL_FLAG
        ptr += strsize(ptr) + 1
        c.printf1(string("%s\n"), ptr)

  c.exit(0)

PUB FindVar(str) | ptr
  ptr := sys#environ_vars
  repeat while byte[ptr]
    if strcomp(str, ptr+1)
      return ptr
    ptr += strsize(ptr) + 1
    ptr += strsize(ptr) + 1

PUB PrintVars | ptr
  ptr := sys#environ_vars
  repeat while byte[ptr]
    ptr := PrintVar(ptr)

PUB PrintVar(ptr) | vartype, name, value
  vartype := byte[ptr++]
  name := ptr
  ptr += strsize(ptr) + 1
  value := ptr
  ptr += strsize(ptr) + 1
  if vartype == GLOBAL_FLAG
    if ContainsBlank(value)
      c.printf2(string("%s=", DOUBLE_QUOTE, "%s", DOUBLE_QUOTE, "\n"), name, value)
    else
      c.printf2(string("%s=%s\n"), name, value)
  return ptr

PUB ContainsBlank(ptr)
  repeat while byte[ptr]
    if byte[ptr++] == " "
      return 1

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
