'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

  'XMODEM chars from ymodem.txt
  SOH=$01
  STX=$02
  EOT=$04
  ACK=$06
  NAK=$15
  CAN=$18
  Cee=$43  'liberties here
  Zee=$1A  'or SUB  (DOS EOF?)

  MSG_TIMEOUT  = -2
  MSG_EOT      = -3
  BYTE_TIMEOUT = -4
  MSG_BADNUM   = -5
  MSG_CRCERR   = -6

OBJ  'Objects Section
  c : "clibsd"
  ser : "cserial"

dat
  pdata long 0

  fcstab word
  word $0000,$1021,$2042,$3063,$4084,$50a5,$60c6,$70e7
  word $8108,$9129,$a14a,$b16b,$c18c,$d1ad,$e1ce,$f1ef
  word $1231,$0210,$3273,$2252,$52b5,$4294,$72f7,$62d6
  word $9339,$8318,$b37b,$a35a,$d3bd,$c39c,$f3ff,$e3de
  word $2462,$3443,$0420,$1401,$64e6,$74c7,$44a4,$5485
  word $a56a,$b54b,$8528,$9509,$e5ee,$f5cf,$c5ac,$d58d
  word $3653,$2672,$1611,$0630,$76d7,$66f6,$5695,$46b4
  word $b75b,$a77a,$9719,$8738,$f7df,$e7fe,$d79d,$c7bc
  word $48c4,$58e5,$6886,$78a7,$0840,$1861,$2802,$3823
  word $c9cc,$d9ed,$e98e,$f9af,$8948,$9969,$a90a,$b92b
  word $5af5,$4ad4,$7ab7,$6a96,$1a71,$0a50,$3a33,$2a12
  word $dbfd,$cbdc,$fbbf,$eb9e,$9b79,$8b58,$bb3b,$ab1a
  word $6ca6,$7c87,$4ce4,$5cc5,$2c22,$3c03,$0c60,$1c41
  word $edae,$fd8f,$cdec,$ddcd,$ad2a,$bd0b,$8d68,$9d49
  word $7e97,$6eb6,$5ed5,$4ef4,$3e13,$2e32,$1e51,$0e70
  word $ff9f,$efbe,$dfdd,$cffc,$bf1b,$af3a,$9f59,$8f78
  word $9188,$81a9,$b1ca,$a1eb,$d10c,$c12d,$f14e,$e16f
  word $1080,$00a1,$30c2,$20e3,$5004,$4025,$7046,$6067
  word $83b9,$9398,$a3fb,$b3da,$c33d,$d31c,$e37f,$f35e
  word $02b1,$1290,$22f3,$32d2,$4235,$5214,$6277,$7256
  word $b5ea,$a5cb,$95a8,$8589,$f56e,$e54f,$d52c,$c50d
  word $34e2,$24c3,$14a0,$0481,$7466,$6447,$5424,$4405
  word $a7db,$b7fa,$8799,$97b8,$e75f,$f77e,$c71d,$d73c
  word $26d3,$36f2,$0691,$16b0,$6657,$7676,$4615,$5634
  word $d94c,$c96d,$f90e,$e92f,$99c8,$89e9,$b98a,$a9ab
  word $5844,$4865,$7806,$6827,$18c0,$08e1,$3882,$28a3
  word $cb7d,$db5c,$eb3f,$fb1e,$8bf9,$9bd8,$abbb,$bb9a
  word $4a75,$5a54,$6a37,$7a16,$0af1,$1ad0,$2ab3,$3a92
  word $fd2e,$ed0f,$dd6c,$cd4d,$bdaa,$ad8b,$9de8,$8dc9
  word $7c26,$6c07,$5c64,$4c45,$3ca2,$2c83,$1ce0,$0cc1
  word $ef1f,$ff3e,$cf5d,$df7c,$af9b,$bfba,$8fd9,$9ff8
  word $6e17,$7e36,$4e55,$5e74,$2e93,$3eb2,$0ed1,$1ef0

PUB ReceiveFile(argc, argv) | packetnum, num, ptr, filesize, fname[10], outfile
  c.enter
  pdata := c.malloc(1028)
  ifnot pdata
    ser.dbprintf0(string("Could not malloc 1028 bytes for the data buffer\n"))
    c.exit(1)
  ser.dbprintf0(string("ymodem receive starts in 15 seconds\n"))
  waitcnt(clkfreq*15+cnt)
  outfile := 0
  ptr := pdata
  packetnum := 0
  repeat
    if packetnum < 2
      ser.tx(CEE)
    num := ReceivePacket(ptr)
    'c.fprintf2(logfile, string("ReceivePacket returned %d %d\n"), num, byte[pdata][0])
    if num == MSG_TIMEOUT
      ser.tx(EOT)
      quit
    elseif num == MSG_EOT
      packetnum := 0
      ser.tx(ACK)
      next
    elseif num =< 0
      ser.tx(NAK)
      next
    if packetnum == 0
      if byte[pdata][2] == 0
        ser.tx(ACK)
        quit
      filesize := DecodeFirstPacket(ptr+2, num, @fname)
      'c.fprintf2(logfile, string("fname = %s, size = %d\n"), @fname, filesize)
      outfile := c.fopen(@fname, string("w"))
      'Open file
    else
      if num > filesize
        num := filesize
      c.fwrite(@byte[pdata][2], 1, num, outfile)
      filesize -= num
    ser.tx(ACK)
    packetnum++
  if outfile
    c.fclose(outfile)
  c.free(pdata)
  c.exit(1)

PUB DecodeFirstPacket(ptr, num, fname) | i, val, filesize
  ifnot byte[ptr]
    byte[fname] := 0
    return -1
  repeat i from 0 to 40
    byte[fname][i] := byte[ptr][i]
    ifnot byte[ptr][i]
      i++
      quit
  filesize := 0
  repeat while i < num
    val := byte[ptr][i++]
    if val < "0" or val > "9"
      quit
    filesize := (filesize * 10) + val - "0"

  return filesize
                 
PUB ReceivePacket(ptr) | num, val, timeout, ptr0
  ptr0 := ptr
  timeout := (clkfreq * 10) + cnt
  ' Get start of packet
  repeat
    repeat while (val := ser.rxcheck) == -1
      if cnt - timeout => 0
        return MSG_TIMEOUT
    'c.fprintf1(logfile, string("rx %02x\n"), val)
    if val == SOH
      num := 128
      quit
    elseif val == STX
      num := 1024
      quit
    elseif val == EOT
      return MSG_EOT
      
  ' Read the packet    
  repeat num + 4
    timeout := clkfreq + cnt
    repeat while (val := ser.rxcheck) == -1
      if cnt - timeout => 0
        return BYTE_TIMEOUT
    byte[ptr++] := val
    
  ' Check for valid packet number pair
  if (byte[ptr0] + byte[ptr0][1]) <> 255
    return MSG_BADNUM
    
  ' Check the CRC
  ifnot CheckCRC(ptr0+2, num)
    return MSG_CRCERR
    
  return num

PUB CheckCRC(ptr, num) | crc
  crc := ComputeCRC(ptr, num)
  return (byte[ptr][num] == (crc >> 8)) and (byte[ptr][num+1] == (crc & $ff))

PUB ComputeCRC(ptr, num)
  repeat num
    result := ((result << 8) & $ffff) ^ fcstab[(result >> 8) ^ byte[ptr++]]

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
