OBJ
  sys : "sysdefs"

PUB runprog(argc1, argv1, sector1, size1, type1)
  coginit(cogid, @run_prog, @argc1)

DAT

run_prog        mov     temp, par
                rdlong  argc, temp
                add     temp, #4
                rdlong  argv, temp
                add     temp, #4
                rdlong  sector, temp
                add     temp, #4
                rdlong  count, temp
                add     count, #511
                shr     count, #9
                add     temp, #4
                rdlong  type, temp

                ' Save clkfreq and clkmode
                rdlong  clkfreq_, #0
                rdbyte  clkmode_, #4

                ' Read the program into memory
loop1           wrlong  sector, block_index
                wrlong  address, buffer_address
                wrlong  read_command, command
loop2           rdlong  temp, command
                cmp     temp, read_command wz
        if_z    jmp     #loop2
                add     sector, #1
                add     address, #256
                add     address, #256
                djnz    count, #loop1

                ' Restore clkfreq and clkmode
                wrlong  clkfreq_, #0
                wrbyte  clkmode_, #4

                ' Check type
                cmp     type, #0 wz
        if_z    jmp     #spincode
                cmp     type, #1 wz
        if_z    jmp     #c_code

stand_alone
                wrlong  stop_command, command
:loop           rdlong  temp, command
                cmp     temp, stop_command wz
        if_z    jmp     #:loop
                rdlong  temp, engine_cog
                sub     temp, #1
                cogstop temp
                jmp     #startcog
c_code
                mov     parm, cparm
                rdlong  temp, #32 + (17*4)
                add     temp, #3*4
                wrlong  argv, temp
                jmp     #startcog

spincode
                ' Get VBASE and DBASE
                rdword  vbase, #8
                rdword  dbase, #10

                ' Clear VAR area
                mov     count, dbase
                sub     count, vbase
                shr     count, #2
loop3           wrlong  zero, vbase
                add     vbase, #4
                djnz    count, #loop3

                ' Add parameters
                wrlong  zero, dbase
                add     dbase, #4
                wrlong  argc, dbase
                add     dbase, #4
                wrlong  argv, dbase

                ' Start cog
startcog        cogid   temp
                and     temp, #7
                or      parm, temp
                coginit parm

engine_cog      long sys#spi_engine_cog
block_index     long sys#spi_block_index
buffer_address  long sys#spi_buffer_address
command         long sys#spi_command
read_command    long "r"
stop_command    long "z"
zero            long 0
address         long 0
parm            long (4 << 16 ) | ($f004 << 2)
cparm           long (sys#rendezvous << 16) | ($20 << 2)
sector          res  1
count           res  1
temp            res  1
clkfreq_        res  1
clkmode_        res  1
vbase           res  1
dbase           res  1
argc            res  1
argv            res  1
type            res  1

