CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

  DOUBLE_QUOTE = $22

OBJ
  c   : "clibsd"
  g   : "glob"
  sys : "sysdefs"
  vs  : "varsubs"

DAT
  nullstr long 0
  redirectin long 0
  redirectout long 0
  scriptline long 0
  ifflag long 0
  whileflag long 0
  shell_level long 0
  bootflag long 0
  scriptfile long 0

VAR
  byte buffer[100]
  byte buffer2[100]
  byte strbuf[100]
  long tokens[25]
  long numtokens

PUB main(argc, argv) | ptr
  vs.RemoveVar(string("<"))
  vs.RemoveVar(string(">"))
  vs.RemoveVar(string(">>"))
  c.enter
  'c.printf1(string("$? = %d\n"), long[sys#return_value])
  LoadStateFromRam
  repeat
    c.CloseRedirect
    if ReadLine
      next
    'c.printf1(string("Trace %d\n"), 1)
    CheckBang
    'c.printf1(string("Trace %d\n"), 2)
    ifnot scriptfile
      WriteHistory
    'c.printf1(string("Trace %d\n"), 3)
    CheckAlias
    'c.printf1(string("Trace %d\n"), 4)
    numtokens := tokenize(@buffer, @tokens)
    'c.printf1(string("Trace %d\n"), 5)
    expand(numtokens)
    'c.printf1(string("Trace %d\n"), 6)
    numtokens := Redirection(numtokens, @tokens)
    'c.printf1(string("Trace %d\n"), 7)
    if scriptfile
      if CheckScriptCommand
        next
    ifnot numtokens
      next
    'c.printf1(string("Trace %d\n"), 8)
    ptr := FindChar(tokens[0], "=")
    if numtokens == 1 and byte[ptr]
      byte[ptr++] := 0
      vs.SaveVar(tokens[0], ptr, vs#LOCAL_FLAG)
    elseif strcomp(tokens, string("pwd"))
      PrintWD(numtokens, @tokens)
    elseif strcomp(tokens, string("cd"))
      ChangeDirectory(numtokens, @tokens)
    elseif strcomp(tokens, string("echo"))
      Echo(numtokens, @tokens)
{
    elseif strcomp(tokens, string("exit"))
      reboot
}
    else
      Execute(numtokens, @tokens)

PUB Execute(argc, argv) | target[20]
  'c.printf0(string("Execute\n"))
  'PrintArgv(argc, argv)
  'c.printf1(string("Trace %d\n"), 9)
  result := FindExecTarget(long[argv], @target)
  'c.printf1(string("Trace %d\n"), 20)
  if result => 2 and result =< 4
    long[argv] := @target
    SaveStateToRam
    if result == 4
      save_sysparm
    c.run(argc, argv, result - 2)
    c.printf1(string("Could not run %s\n"), long[argv])
    LoadStateFromRam
  elseif result == 1
    long[argv] := @target
    OpenScriptFile(argc, argv)

PUB SkipChar(ptr, val)
  repeat while byte[ptr]
    if byte[ptr] <> val
      quit
    ptr++
  return ptr

PUB FindChar(ptr, val)
  repeat while byte[ptr]
    if byte[ptr] == val
      quit
    ptr++
  return ptr

PUB PrintWD(argc, argv)
  if c.OpenRedirect '(argc, argv)
    return 1
  c.getcwd(@buffer, 100)
  c.printf1(string("%s\n"), @buffer)

PUB ChangeDirectory(argc, argv) | path[25]
  if c.OpenRedirect '(argc, argv)
    return 1
  if argc > 2
    c.printf0(string("cd [path]\n"))
    return 1
  if argc == 1
    c.strcpy(@path, string("/"))
  else
    c.resolve_path(long[argv][1], @path)
    ifnot strcomp(@path, string("/"))
      ifnot c.getmod(@path) & %10000
        c.printf1(string("%s is not a directory\n"), @path)
        return 1
  if c.chdir(@path)
    c.printf1(string("Could not find path %s\n"), @path)
    return 2
  vs.SaveVar(string("PWD"), @path, vs#GLOBAL_FLAG)

PUB Echo(argc, argv) | i, ptr, space, globdata, str[25]
  if c.OpenRedirect '(argc, argv)
    return 1
  if argc > 1
    space := 0
    repeat i from 1 to argc - 1
      globdata := 0
      repeat while (ptr := g.glob(long[argv][i], @globdata, @str))
        c.printf2(string("%s%s"), @space, ptr)
        space := " "
  c.printf0(string("\n"))

PUB FindExecTarget(fname, pathstr) | temp, infile, typestr[8]
  'c.printf1(string("FindExecTarget %s\n"), fname)
  c.strcpy(pathstr, fname)
  'c.printf1(string("pathstr = %s\n"), pathstr)
  'c.CheckStackSpace
  'c.CheckMallocSpace
  'c.printf1(string("Trace %d\n"), 10)
  repeat 2
    'c.printf1(string("Trace %d\n"), 11)
    'c.printf0(string("repeat\n"))
    if (infile := c.fopen(pathstr, string("r")))
      'c.printf1(string("infile nonzero -- %d\n"), infile)
      quit
    'c.printf1(string("infile zero -- %d\n"), infile)
    temp := FindChar(pathstr, "/")
    if byte[temp]
      quit
    c.strcpy(pathstr, string("/bin/"))
    c.strcat(pathstr, fname)

  'c.printf1(string("infile equals %d\n"), infile)
  'c.printf1(string("Trace %d\n"), 12)

  ifnot infile
    c.printf1(string("1Could not open %s\n"), fname)
    return

  longfill(@typestr, 0, 8)
  c.fread(@typestr, 1, 32, infile)
  c.fclose(infile)

  'c.printf1(string("Trace %d\n"), 13)
  ifnot c.strncmp(@typestr, string("SPINb"), 5)
    result := 2
  elseifnot c.strncmp(@typestr, string("CAPPb"), 5)
    result := 3
  elseif typestr => 80_000_000 and typestr =< 120_000_000 ' Stand-alone
    result := 4
  elseifnot c.strncmp(@typestr, string("#shell"), 6)
    'c.printf1(string("%s is a shell script\n"), fname)
    result := 1
  else
    c.printf1(string("%s is not an executable file\n"), fname)

PUB Redirection(argc, argv) | i, argc1, ptr, char, outptr, inptr, outstr
  if argc =< 0
    return argc
  i := 1
  argc1 := 1
  inptr := @nullstr
  outptr := @nullstr
  repeat while i < argc
    ptr := long[argv][i]
    char := byte[ptr++]
    if char == "<"
      if byte[ptr]
        inptr := ptr
      elseif ++i < argc
        inptr := long[argv][i]
      vs.SaveVar(string("<"), inptr, vs#LOCAL_FLAG)
    elseif char == ">"
      if byte[ptr] == ">"
        ptr++
        outstr := STRING(">>")
      else
        outstr := STRING(">")
      if byte[ptr]
        outptr := ptr
      elseif ++i < argc
        outptr := long[argv][i]
      vs.SaveVar(outstr, outptr, vs#LOCAL_FLAG)
    elseif char
      long[argv][argc1++] := long[argv][i]
    i++
  'long[argv][argc1] := inptr
  'long[argv][argc1+1] := outptr
  return argc1

{
pub save_sysparm | outfile, ptr
  outfile := c.fopen(string("/_sysparm"), string("w"))
  ptr := sys#unixtime
  repeat 3
    c.fprintf1(outfile, string("%d\n"), long[ptr])
    ptr += 4
  c.fclose(outfile)
}

pub WriteHistory | outfile, ptr
  ptr := SkipChar(@buffer, " ")
  if byte[ptr]
    if (outfile := c.fopen(string("/_history"), string("a")))
      c.fprintf1(outfile, string("%s\n"), @buffer)
      c.fclose(outfile)

PUB RemoveCRLF(str) | len
  len := strsize(str)
  str += len - 1
  repeat while (len > 0)
    if (byte[str] <> 10 and byte[str] <> 13)
      quit
    byte[str--] := 0
    len--

PUB FindBlank(str) | val
  val := " "
  repeat while byte[str]
    if byte[str] == val
      if val == " "
        quit
      val := " "
    elseif byte[str] == DOUBLE_QUOTE
      val := DOUBLE_QUOTE
    str++
  return str

PUB tokenize(str, tokens_0) | ptr, num
  num := 0
  repeat while (byte[str])
    ptr := SkipChar(str, " ")
    if (byte[ptr] == 0)
      quit
    str := FindBlank(ptr)
    if (byte[str])
      byte[str++] := 0
    long[tokens_0][num++] := ptr
  return num

PUB GetVarName(ptr1, ptr2) | brace, val
  if byte[ptr1] == "#" or byte[ptr1] == "?"
    byte[ptr2++] := byte[ptr1++]
    byte[ptr2] := 0
    return ptr1
  brace := 0
  if byte[ptr1] == "{"
    brace := 1
    ptr1++
  repeat while (val := byte[ptr1])
    ifnot (c.isdigit(val) or vs.IsAlpha(val) or val == "_")
      if val == "}" and brace
        ptr1++
      quit
    byte[ptr2++] := byte[ptr1++]
  byte[ptr2] := 0
  return ptr1

PUB expand(num) | i, ptr1, ptr2, ptr3, len, varname[20]
  i := 0
  ptr2 := @buffer2
  repeat while i < num
    ptr1 := tokens[i]
    tokens[i] := ptr2
    repeat while byte[ptr1]
      if byte[ptr1] == DOUBLE_QUOTE
        ptr1++
        next
      if byte[ptr1] == "$"
        ptr1 := GetVarName(ptr1 + 1, @varname)
        ptr3 := vs.GetVarVal(@varname)
        len := strsize(ptr3)
        bytemove(ptr2, ptr3, len)
        ptr2 += len
        next
      if byte[ptr1] == "\"
        ifnot byte[++ptr1]
          quit
      'c.printf1(string("Copy %c\n"), byte[ptr1])
      byte[ptr2++] := byte[ptr1++]
    byte[ptr2++] := 0
    i++

PUB CheckBang | num, i, histfile, ptr
  ptr := SkipChar(@buffer, " ")
  ifnot byte[ptr]
    return
  if buffer[0] == "!"
    c.strcpy(@strbuf, @buffer + 1)
    if buffer[1] == "!"
      num := -1
    elseif c.isdigit(buffer[1])
      c.sscanf1(@buffer[1], string("%d"), @num)
    else
      i := 0
      num := 0
      histfile := c.fopen(string("/_history"), string("r"))
      if histfile
        repeat while c.fgets(@buffer, 100, histfile)
          i++
          ifnot c.strncmp(@buffer, @strbuf, strsize(@strbuf))
            num := i
        c.fclose(histfile)
      ifnot num
        c.printf1(string("Could not find event !%s\n"), @strbuf)
        return 1

    histfile := c.fopen(string("/_history"), string("r"))
    i := 0
    if histfile
      repeat while c.fgets(@buffer, 100, histfile)
        if ++i == num
          quit
      c.fclose(histfile)

    if i and ((num == -1) or (num == i))
      c.printf1(string("%s"), @buffer)
      num := strsize(@buffer)
      if num
        buffer[num-1] := 0
    else
      c.printf1(string("Could not find event !%s\n"), @strbuf)
      return 1
{
  histfile := c.fopen(string("/_history"), string("a"))
  if histfile
    c.fprintf1(histfile, string("%s\n"), @buffer)
    c.fclose(histfile)
}

PUB CheckAlias | len, ptr, ptr1, ptr2, ptr3

  ' Get the first token
  ptr := SkipChar(@buffer, " ")
  ifnot byte[ptr]
    return
  ptr1 := FindChar(ptr, " ")
  len := ptr1 - ptr
  bytemove(@strbuf, ptr, len)
  strbuf[len] := 0

  ptr2 := vs.FindAlias(@strbuf)
  ifnot ptr2
    return
  ptr3 := ptr2 + strsize(ptr2) + 1

  'c.printf2(string("CheckAlias: %s %s\n"), ptr2+1, ptr3)

  c.strcpy(@strbuf, ptr3)
  c.strcat(@strbuf, ptr1)
  c.strcpy(@buffer, @strbuf)

PUB OpenScriptFile(argc, argv) | fname
  fname := long[argv]
  'c.printf1(string("OpenScriptFile: Opening %s\n"), fname)
  if scriptfile
    c.fclose(scriptfile)
    'c.printf0(string("Closing script file\n"))
  SaveStateToFile
  if (scriptfile := c.fopen(fname, string("r")))
    scriptline := 0
    ifflag := 0
    whileflag := 0
    'shell_level := 0
    bootflag := 0
    vs.SaveVar(string("SCRIPT_FILE"), fname, vs#LOCAL_FLAG)
    AddParms(argc, argv)
  else
    c.printf0(string("Open failed\n"))
    LoadStateFromFile

PUB SaveStateToRam
  'c.printf1(string("SaveStateToRam: scriptline = %d\n"), scriptline)
  if scriptfile
    long[sys#scriptline] := scriptline 
    long[sys#ifflag] := ifflag 
    long[sys#whileflag] := whileflag 
    long[sys#shell_level] := shell_level 
    long[sys#bootflag] := bootflag 
    c.fclose(scriptfile)

PUB LoadStateFromRam | scriptname
  'c.printf0(string("LoadStateFromRam\n"))
  scriptname := GetScriptName
  if byte[scriptname]
    'c.printf1(string("Opening script file %s\n"), scriptname)
    scriptfile := c.fopen(scriptname, string("r"))
  if scriptfile
    scriptline := long[sys#scriptline]
    ifflag := long[sys#ifflag]
    whileflag := long[sys#whileflag]
    shell_level := long[sys#shell_level]
    bootflag := long[sys#bootflag]
    'c.printf1(string("LoadStateFromRam: scriptline = %d\n"), scriptline)
    JumpScriptLine

PUB JumpScriptLine
  c.fseek(scriptfile, 0, c#SEEK_SET)
  if scriptline > 0
    repeat scriptline
      c.fgets(@buffer, 100, scriptfile)

PUB CheckScriptCommand
  'c.printf0(string("CheckScriptCommand\n"))

  ifnot scriptfile
    return

  if (whileflag == - 1)
    if (not c.strcmp(tokens[0], string("done")))
      whileflag := 0
    return 1
  if (not c.strcmp(tokens[0], string("else")))
    ifflag := not ifflag
    return 1
  elseif (not c.strcmp(tokens[0], string("fi")))
    ifflag := 0
    return 1
  elseif (ifflag)
    return 1

  if (not c.strcmp(tokens[0], string("exit")))
    c.fclose(scriptfile)
    LoadStateFromFile
    return 1
  elseif (not c.strcmp(tokens[0], string("setlev")))
    shell_level := vs.atol(tokens[1])
    return 1
  elseif (not c.strcmp(tokens[0], string("if")))
    numtokens := CheckTest(numtokens, @tokens)
    Execute(numtokens-1, @tokens[1])
    return 1
  elseif (not c.strcmp(tokens[0], string("then")))
    ifflag := long[sys#return_value]
    return 1
  elseif (not c.strcmp(tokens[0], string("while")))
    numtokens := CheckTest(numtokens, @tokens)
    Execute(numtokens-1, @tokens[1])
    return 1
  elseif (not c.strcmp(tokens[0], string("do")))
    if long[sys#return_value]
      whileflag := - 1
    else
      whileflag := scriptline - 2
    return 1
  elseif (not c.strcmp(tokens[0], string("done")))
    if whileflag
      scriptline := whileflag
      whileflag := 0
      JumpScriptLine
    return 1

PUB PrintArgv(argc, argv) | i
  c.printf1(string("PrintArgv %d --"), argc)
  i := 0
  repeat while i < argc
    c.printf1(string(" <%s>"), long[argv][i++])
  c.printf0(string("\n"))

PUB CheckTest(argc, argv)
  'c.printf0(string("CheckTest\n"))
  'PrintArgv(argc, argv)
  if argc > 1
    if strcomp(long[argv][1], string("["))
      long[argv][1] := string("/bin/test")
      if argc > 2
        if strcomp(long[argv][argc-1], string("]"))
          argc--
  'PrintArgv(argc, argv)
  'long[argv][argc] := @nullstr
  'long[argv][argc+1] := @nullstr
  return argc

PUB ReadLine | ptr
  if scriptfile
    if c.fgets(@buffer, 100, scriptfile) =< 0
      c.fclose(scriptfile)
      LoadStateFromFile
      return 1
    RemoveCRLF(@buffer)
    scriptline++
  else
    c.printf0(string("shell> "))
    c.gets(@buffer)
  ptr := SkipChar(@buffer, " ")
  ifnot byte[ptr]
    return 1
  if byte[@buffer][0] == "#"
    return 1

PUB AddParms(argc, argv) | i, numstr[3]
  i := 1
  c.sprintf1(@numstr, string("%d"), argc - 1)
  vs.SaveVar(string("#"), @numstr, vs#PARM_FLAG)
  repeat while (i < argc)
    c.sprintf1(@numstr, string("%d"), i)
    vs.SaveVar(@numstr, long[argv][i], vs#PARM_FLAG)
    i++

PUB GetScriptName
  if (result := vs.FindVar(string("SCRIPT_FILE")))
    result += strsize(result) + 1
  else
    result := @nullstr

PUB SaveStateToFile | outfile, fname[5]
  c.strcpy(@fname, string("/tmp/_shellva.rsa"))
  byte[@fname][16] += shell_level
  outfile := c.fopen(@fname, string("w"))
  ifnot outfile
    c.printf0(string("SaveState: Could not open file\n"))
    return
  c.fprintf1(outfile, string("%s\n"), GetScriptName)
  SaveScriptStuff(outfile)
{
  c.fprintf3(outfile, string("%d %d %d\n"), ifflag, whileflag, scriptline)
  ptr := sys#environ_vars
  repeat while byte[ptr]
    ptr1 := ptr
    ptr += strsize(ptr) + 1
    c.fprintf2(outfile, string("%s %s\n"), ptr1, ptr)
    ptr += strsize(ptr) + 1
}
  RemoveLocalVars
  shell_level++
  c.fclose(outfile)

PUB save_sysparm | outfile
  outfile := c.fopen(string("/_sysparm"), string("w"))
  ifnot outfile
    c.printf0(string("Can't open /_sysparm\n"))
    return
  c.fprintf1(outfile, string("%d\n"), long[sys#unixtime])
  c.fprintf3(outfile, string("%d %d %d\n"), long[sys#timezone], long[sys#config], shell_level)
  SaveScriptStuff(outfile)
  c.fclose(outfile)

PUB SaveScriptStuff(outfile) | ptr, ptr1
  c.fprintf3(outfile, string("%d %d %d\n"), ifflag, whileflag, scriptline)
  ptr := sys#environ_vars
  repeat while byte[ptr]
    ptr1 := ptr
    ptr += strsize(ptr) + 1
    c.fprintf2(outfile, string("%s %s\n"), ptr1, ptr)
    ptr += strsize(ptr) + 1

PUB RemoveLocalVars | ptr
  ptr := sys#environ_vars
  repeat while byte[ptr]
    if byte[ptr] == VS#GLOBAL_FLAG
      ptr += strsize(ptr) + 1
      ptr += strsize(ptr) + 1
    else
      vs.RemoveEntry(ptr)

PUB InitializeState(error_flag)
  shell_level := 0
  scriptfile := 0
  if error_flag
    RemoveLocalVars
  else
    vs.RemoveVar(string("SCRIPT_FILE"))
  vs.SaveVar(string("#"), string("0"), vs#PARM_FLAG)

PUB LoadStateFromFile | infile, ptr, fname[5], scriptname, firstline[20]
  'c.printf1(string("LoadStateFromFile: shell_level = %d\n"), shell_level)
  ' Check if shell level less than or equal to zero -- zero happens at startup
  if shell_level =< 0
    if shell_level
      c.printf1(string("LoadStateFromFile: Error, shell_level = %d\n"), shell_level)
      InitializeState(1)
    else
      InitializeState(0)
    return

  ' Drop down a level
  shell_level--
  c.strcpy(@fname, string("/tmp/_shellva.rsa"))
  byte[@fname][16] += shell_level
  ifnot (infile := c.fopen(@fname, string("r")))
    c.printf1(string("LoadStateFromFile: Error, could not open %s\n"), @fname)
    InitializeState(1)
    return
  'c.printf1(string("LoadStateFromFile: opened %s\n"), @fname)
  c.fgets(@buffer, 100, infile)
  byte[@buffer][strsize(@buffer)-1] := 0
  c.strcpy(@firstline, @buffer)
  c.fgets(@buffer, 100, infile)
  c.sscanf3(@buffer, string("%d %d %d"), @ifflag, @whileflag, @scriptline)
  'c.printf4(string("LoadStateFromFile: %s %d %d %d\n"), @firstline, ifflag, whileflag, scriptline)
  ptr := sys#environ_vars
  repeat while c.fgets(ptr, 100, infile)
    ptr := vs.FindChar(ptr, " ")
    byte[ptr++] := 0
    ptr += strsize(ptr) - 1
    byte[ptr++] := 0
  byte[ptr] := 0
  c.fclose(infile)

  ' Open script file
  scriptname := GetScriptName
  ifnot strcomp(scriptname, @firstline)
    c.printf0(string("LoadStateFromFile: Error, names don't match"))
    c.printf2(string("LoadStateFromFile: %s %s\n"), @firstline, scriptname)
  if shell_level == 0 and not byte[scriptname]
    scriptfile := 0
  elseif shell_level and not byte[scriptname]
    c.printf1(string("LoadStateFromFile: Error, no script file at level %d\n"), shell_level)
    InitializeState(1)
  elseif (scriptfile := c.fopen(scriptname, string("r")))
    JumpScriptLine
  else
    c.printf1(string("LoadStateFromFile: Error, could not open %s\n"), scriptname)
    InitializeState(1)

