'**********************************************
'* Spin code generated by cspin version 0.060 *
'**********************************************
'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************

CON
  HDR_SIZE = 4

  ' typedef struct StringS
  s_next = 0
  s_size = 1

DAT
  smfreelist long 0

PUB smallocinit(curr, size)
  smfreelist := curr
  word[curr]{s_next} := 0
  word[curr][s_size] := size


' Allocate a block of "size" bytes.  Return a pointer to the block if
' successful, or zero if a large enough memory block could not be found
PUB smalloc(size) | prev, curr, nexx
  if (size =< 0)
    return 0
  ' Adjust size to nearest long plus the header size
  size := ((size + 3) & (!3)) + HDR_SIZE
  ' Search for a block of memory
  prev := 0
  curr := smfreelist
  repeat while (curr)
    if (word[curr][s_size] => size)
      quit
    prev := curr
    curr := word[curr]{s_next}
  ' Return null if block not found
  if (curr == 0)
    return 0
  ' Get next pointer
  nexx := word[curr]{s_next}
  ' Split block if larger than needed
  if (word[curr][s_size] => size + HDR_SIZE + 16)
    nexx := curr + size
    word[nexx]{s_next} := word[curr]{s_next}
    word[nexx][s_size] := word[curr][s_size] - size
    word[curr]{s_next} := nexx
    word[curr][s_size] := size
  ' Remove block from the free list
  word[curr]{s_next} := 0
  if (prev)
    word[prev]{s_next} := nexx
  else
    smfreelist := nexx
  return curr

' Insert a memory block back into the free list.  Merge blocks together if
' the memory block is contiguous with other blocks on the list.
PUB sfree(curr) | prev, nexx
  prev := 0
  nexx := smfreelist
  ' Find Insertion Point
  repeat while (nexx)
    if (curr => prev and curr =< nexx)
      quit
    prev := nexx
    nexx := word[nexx]{s_next}
  ' Merge with the previous block if contiguous
  if (prev and prev + word[prev][s_size] == curr)
    word[prev][s_size] += word[curr][s_size]
    ' Also merge with next block if contiguous
    if (prev + word[prev][s_size] == nexx)
      word[prev][s_size] += word[nexx][s_size]
      word[prev]{s_next} := word[nexx]{s_next}
  ' Merge with the next block if contiguous
  elseif (nexx and curr + word[curr][s_size] == nexx)
    word[curr][s_size] += word[nexx][s_size]
    word[curr]{s_next} := word[nexx]{s_next}
    if (prev)
      word[prev]{s_next} := curr
    else
      smfreelist := curr
  ' Insert in the middle of the free list if not contiguous
  elseif (prev)
    word[prev]{s_next} := curr
    word[curr]{s_next} := nexx
  ' Otherwise, insert at beginning of the free list
  else
    smfreelist := curr
    word[curr]{s_next} := nexx

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
