CON
  _clkmode = xinput
  _xinfreq = $4E505350 ' PSPN
  DOUBLE_QUOTE = $22

OBJ
  c : "clib_os"
  sys : "sysdefs"
  vs : "varsubs"

PUB start(argc, argv)
  main(argc, argv)

VAR
  byte buffer[100]
  byte buffer2[100]
  long tokens[25]

DAT
  datstr byte
  nullstr long 0
  shell_level long 0
  ifflag long 0
  whileflag long 0
  skipflag long 0
  runmode long 0
  scriptfile long 0
  scriptline long 0
  scriptname long 0[20]
  redirectin long 0
  redirectout long 0
  strbuf long 0[20]
  strptr long 0
  retvalstr long 0[4]
  CouldNotOpen byte "Could not open %s\n", 0
  RedirectionError byte "Redirection error\n", 0

' ###################################################

PUB SaveState | outfile, ptr, ptr1, fname[5]
  c.strcpy(@fname, string("/tmp/_shellva.rsa"))
  byte[@fname][16] += shell_level
  outfile := c.fopen(@fname, string("w"))
  ifnot outfile
    c.printf0(string("SaveState: Could not open file\n"))
    return
  c.fprintf1(outfile, string("%s\n"), @scriptname)
  c.fprintf4(outfile, string("%d %d %d %d\n"), ifflag, whileflag, skipflag, scriptline)
  ptr := sys#environ_vars
  repeat while byte[ptr]
    ptr1 := ptr
    ptr += strsize(ptr) + 1
    c.fprintf2(outfile, string("%s %s\n"), ptr1, ptr)
    ptr += strsize(ptr) + 1
  RemoveLocalVars
  shell_level++
  c.fclose(outfile)

PUB RemoveLocalVars | ptr
  ptr := sys#environ_vars
  repeat while byte[ptr]
    if byte[ptr] == VS#GLOBAL_FLAG
      ptr += strsize(ptr) + 1
      ptr += strsize(ptr) + 1
    else
      vs.RemoveEntry(ptr)

PUB InitializeScriptVars
  shell_level := 0
  scriptfile := c.getstdin
  c.strcpy(@scriptname, string("stdin"))

PUB RestoreState | infile, ptr, fname[5]
  ' Check if shell level less than or equal to zero -- zero happens at startup
  if shell_level =< 0
    if shell_level
      c.printf1(string("RestoreState: Error, shell_level = %d\n"), shell_level)
    InitializeScriptVars
    return

  ' Drop down a level
  shell_level--
  c.strcpy(@fname, string("/tmp/_shellva.rsa"))
  byte[@fname][16] += shell_level
  ifnot (infile := c.fopen(@fname, string("r")))
    c.printf1(string("RestoreState: Error, could not open %s\n"), @fname)
    InitializeScriptVars
    return
  c.fgets(@buffer, 100, infile)
  byte[@buffer][strsize(@buffer)-1] := 0
  c.strcpy(@scriptname, @buffer)
  c.fgets(@buffer, 100, infile)
  c.sscanf4(@buffer, string("%d %d %d %d"), @ifflag, @whileflag, @skipflag, @scriptline)
  'c.printf5(string("RestoreState: %s %d %d %d %d\n"), @scriptname, ifflag, whileflag, skipflag, scriptline)
  ptr := sys#environ_vars
  repeat while c.fgets(ptr, 100, infile)
    ptr := vs.FindChar(ptr, " ")
    byte[ptr++] := 0
    ptr += strsize(ptr) - 1
    byte[ptr++] := 0
  byte[ptr] := 0
  c.fclose(infile)

  ' Open script file
  if shell_level == 0 and strcomp(@scriptname, string("stdin"))
    scriptfile := c.getstdin
  elseif (scriptfile := c.fopen(@scriptname, string("r")))
    repeat scriptline
      if c.fgets(@buffer, 100, scriptfile) =< 0
        quit
  else
    c.printf1(string("RestoreState: Error, could not open %s\n"), @scriptname)
    InitializeScriptVars

PUB CheckTest(argc, argv)
  if argc > 1
    if strcomp(long[argv][1], string("["))
      long[argv][1] := string("/bin/test")
      if argc > 2
        if strcomp(long[argv][argc-1], string("]"))
          argc--
  return argc

PUB AddParms(argc, argv) | i, numstr[3]
  i := 1
  c.sprintf1(@numstr, string("%d"), argc - 1)
  vs.SaveVar(string("#"), @numstr, vs#PARM_FLAG)
  repeat while (i < argc)
    c.sprintf1(@numstr, string("%d"), i)
    vs.SaveVar(@numstr, long[argv][i], vs#PARM_FLAG)
    i++

PUB main(argc, argv) | i, num, ptr, numstr[3], bootflag

  scriptline := 0
  ifflag := 0
  whileflag := 0
  skipflag := 0
  AddParms(argc, argv)
  shell_level := 0
  bootflag := 0

  if argc == 2 and strcomp(long[argv][1], string("boot"))
    load_sysparm
    if c.remove(string("/tmp/__reboot")) => 0
      c.strcpy(@scriptname, string("/tmp/_restart.spl"))
      scriptfile := c.fopen(@scriptname, string("r"))
    ifnot scriptfile
      bootflag := 1
      i := string("/bin/splash0")
      Execute(1, @i)
      c.strcpy(@scriptname, string("/_startup"))
      scriptfile := c.fopen(@scriptname, string("r"))
  else
    c.strcpy(@scriptname, string("/tmp/_restart.spl"))
    scriptfile := c.fopen(@scriptname, string("r"))

  ifnot scriptfile
    InitializeScriptVars
  elseif bootflag
    SaveState

  repeat
    ' Close redirection files if opened
    if redirectin
      c.resetstdin
      c.fclose(redirectin)
      redirectin := 0
    if redirectout
      c.resetstdout
      c.fclose(redirectout)
      redirectout := 0

{
    CheckAlias
}

    if (scriptfile == c.getstdin)
      c.printf0(string("splash> "))
{
      c.getcwd(@buffer, 100)
      c.printf1(STRING("\n%s$ "), @buffer)
      c.gets(@buffer)
      if CheckBang
        next
}

    if (not c.fgets(@buffer, 100, scriptfile))
      if (scriptfile == c.getstdin)
        quit
      c.fclose(scriptfile)
      RestoreState
      next
    scriptline++
    if byte[@buffer][0] == "#"
      next
    RemoveCRLF(@buffer)
    if (scriptline < skipflag)
      next
    if (scriptfile == c.getstdin)
      WriteHistory
    skipflag := 0
    num := tokenize(@buffer, @tokens)
    expand(num)
    'num := Redirection(num, @tokens)
    if (not num)
      next
    if (whileflag == - 1)
      if (not c.strcmp(tokens[0], string("done")))
        whileflag := 0
      next
    if (not c.strcmp(tokens[0], string("else")))
      ifflag := not ifflag
      next
    elseif (not c.strcmp(tokens[0], string("fi")))
      ifflag := 0
      next
    elseif (ifflag)
      next
    ptr := vs.FindChar(tokens[0], "=")
    if num == 1 and byte[ptr]
      byte[ptr++] := 0
      vs.SaveVar(tokens[0], ptr, vs#LOCAL_FLAG)
    elseif (not c.strcmp(tokens[0], string("exit")))
      if (scriptfile == c.getstdin)
        quit
      c.fclose(scriptfile)
      RestoreState
    elseif (not c.strcmp(tokens[0], string("setlev")))
      shell_level := vs.atol(tokens[1])
    elseif (not c.strcmp(tokens[0], string("if")))
      num := CheckTest(num, @tokens)
      Execute(num-1, @tokens[1])
    elseif (not c.strcmp(tokens[0], string("then")))
      ifflag := long[sys#return_value]
    elseif (not c.strcmp(tokens[0], string("while")))
      num := CheckTest(num, @tokens)
      Execute(num-1, @tokens[1])
    elseif (not c.strcmp(tokens[0], string("do")))
      if long[sys#return_value]
        whileflag := - 1
      else
        whileflag := scriptline - 1
    elseif (not c.strcmp(tokens[0], string("done")))
      if (scriptfile <> c.getstdin and whileflag)
        skipflag := whileflag
        whileflag := 0
        scriptline := 0
        c.fseek(scriptfile, 0, c#SEEK_SET)
    else
      Execute(num, @tokens) == 1
  return 0

PUB RemoveCRLF(str) | len
  len := strsize(str)
  str += len - 1
  repeat while (len > 0)
    if (byte[str] <> 10 and byte[str] <> 13)
      quit
    byte[str--] := 0
    len--

PUB FindBlank(str) | val
  val := " "
  repeat while byte[str]
    if byte[str] == val
      if val == " "
        quit
      val := " "
    elseif byte[str] == DOUBLE_QUOTE
      val := DOUBLE_QUOTE
    str++
  return str

PUB tokenize(str, tokens_0) | ptr, num
  num := 0
  repeat while (byte[str])
    ptr := vs.SkipChar(str, " ")
    if (byte[ptr] == 0)
      quit
    str := FindBlank(str)
    if (byte[str])
      byte[str++] := 0
    long[tokens_0][num++] := ptr
  return num

PUB GetVarName(ptr1, ptr2) | brace, val
  if byte[ptr1] == "#" or byte[ptr1] == "?"
    byte[ptr2++] := byte[ptr1++]
    byte[ptr2] := 0
    return ptr1
  brace := 0
  if byte[ptr1] == "{"
    brace := 1
    ptr1++
  repeat while (val := byte[ptr1])
    ifnot (c.isdigit(val) or vs.IsAlpha(val))
      if val == "}" and brace
        ptr1++
      quit
    byte[ptr2++] := byte[ptr1++]
  byte[ptr2] := 0
  return ptr1

PUB expand(num) | i, ptr1, ptr2, ptr3, len, varname[20]
  i := 0
  ptr2 := @buffer2
  repeat while i < num
    ptr1 := tokens[i]
    tokens[i] := ptr2
    repeat while byte[ptr1]
      if byte[ptr1] == DOUBLE_QUOTE
        ptr1++
        next
      if byte[ptr1] == "$"
        ptr1 := GetVarName(ptr1 + 1, @varname)
        ptr3 := vs.GetVarVal(@varname)
        len := strsize(ptr3)
        bytemove(ptr2, ptr3, len)
        ptr2 += len
        next
      if byte[ptr1] == "\"
        ifnot byte[++ptr1]
          quit
      'c.printf1(string("Copy %c\n"), byte[ptr1])
      byte[ptr2++] := byte[ptr1++]
    byte[ptr2++] := 0
    i++

PUB Execute(argc, argv) | i, pathstr[20]
  strptr := @strbuf

  ifnot (i := FindExecTarget(long[argv][0], @pathstr))
    return i

  if i == 1
    if scriptfile <> c.getstdin
      c.fclose(scriptfile)
    SaveState
    scriptfile := c.fopen(@pathstr, string("r"))
    scriptline := 0
    if byte[@pathstr] <> "/"
      c.getcwd(@scriptname, 50)
      c.strcat(@scriptname, string("/"))
    else
      scriptname := 0
    c.strcat(@scriptname, @pathstr)
    AddParms(argc, argv)
    ifnot scriptfile
      i := -1
      c.printf1(@CouldNotOpen, @pathstr)
    {
    else
      if argc > 1
        c.sscanf1(long[argv][1], string("%d"), @scriptline)
        repeat scriptline
          if c.fgets(@buffer, 100, scriptfile) =< 0
            quit
    }
  elseif i := run(@pathstr, argc, argv, runmode)
    if i == -2
      c.printf1(string("Not enough memory to run %s\n"), @pathstr)
    else
      c.printf1(@CouldNotOpen, @pathstr)
  return i

PUB CheckMemoryAvail(size)
  if runmode & sys#run_kill_caller
    return
  if redirectin or redirectout
    return
  if (result := c.malloc(size + 900))
    c.free(result)
  else
    runmode |= sys#run_kill_caller | cogid

PUB FindExecTarget(fname, pathstr) | size, temp, infile, typestr[8]
  c.strcpy(pathstr, fname)
  repeat 2
    if (infile := c.fopen(pathstr, string("r")))
      quit
    temp := vs.FindChar(pathstr, "/")
    if byte[temp]
      quit
    c.strcpy(pathstr, string("/bin/"))
    c.strcat(pathstr, fname)

  ifnot infile
    c.printf1(@CouldNotOpen, fname)
    return

  longfill(@typestr, 0, 8)
  c.fread(@typestr, 1, 32, infile)
  c.fseek(infile, 0, c#SEEK_END)
  size := c.ftell(infile)
  c.fclose(infile)

  if typestr == $4e495053 ' SPIN
    size := word[@typestr][5] ' The Spin program size is determined by dbase
    'c.printf0(string("Spin Program Detected\n"))
    CheckMemoryAvail(size)
    result := 2
  elseif typestr == $50504143 ' CAPP
    'c.printf0(string("C App Detected\n"))
    runmode |= sys#run_c_program | cogid
    CheckMemoryAvail(size)
    result := 4
  elseif typestr == $4F525053 ' SPRO
    'c.printf0(string("Spin Program Detected\n"))
    runmode := sys#run_spin_program | sys#run_at_address0 | sys#run_stand_alone | cogid
    result := 5
  elseif typestr == $4F525043 ' CPRO
    'c.printf0(string("C Program Detected\n"))
    runmode := sys#run_c_program | sys#run_stand_alone | cogid
    result := 6
  elseif typestr => 80_000_000 and typestr =< 120_000_000
    ifnot runmode
      'c.printf0(string("Stand-alone Program Detected\n"))
      runmode := sys#run_at_address0 | sys#run_stand_alone | cogid
    result := 3
  elseifnot c.strncmp(@typestr, string("#shell"), 6)
    result := 1
  else
    c.printf1(string("%s is not an executable file\n"), fname)

PUB AddToCogTable(cognum, type, name, startaddr, size) | entryptr
  entryptr := sys#cogtable + (cognum * 24)
  byte[entryptr] := type
  bytemove(entryptr+1, name, 19)
  byte[entryptr+19] := 0
  word[entryptr+20] := startaddr
  word[entryptr+22] := size

PUB RemoveFromCogTable(cognum) | entryptr
  entryptr := sys#cogtable + (cognum * 24)
  byte[entryptr] := 0

PUB Redirection(argc, argv) | i, argc1, ptr, char, mode
  runmode := sys#run_shell_wait
  if (argc < 2)
    return argc
  argc1 := 1
  repeat i from 1 to argc - 1
    ptr := long[argv][i]
    char := byte[ptr++]
    if char == "<"
      if (byte[ptr] == 0)
        ptr := long[argv][++i]
        if (i => argc)
          c.printf0(@RedirectionError)
          argc1 := 0
          quit
      redirectin := c.fopen(ptr, string("r"))
      ifnot redirectin
        c.printf1(@CouldNotOpen, ptr)
        argc1 := 0
        quit
      else
        c.setstdin(redirectin)
    elseif char == ">"
      if (byte[ptr] == ">")
        ptr++
        mode := string("a")
      else
        mode := string("w")
      if (byte[ptr] == 0)
        ptr := long[argv][++i]
        if (i => argc)
          c.printf0(@RedirectionError)
          argc1 := 0
          quit
      redirectout := c.fopen(ptr, mode)
      ifnot redirectout
        c.printf1(@CouldNotOpen, ptr)
        argc1 := 0
        quit
      else
        c.setstdout(redirectout)
    elseif char == "&"
      if byte[ptr] == "&"       ' Kill shell
        ptr++
        runmode := sys#run_kill_caller | cogid
      elseif byte[ptr] == "^"   ' Shell waits
        ptr++
      elseif byte[ptr] == "*"   ' Run stand-alone
        ptr++
        runmode := sys#run_stand_alone | cogid
      else                      ' Shell does not wait
        runmode := sys#run_shell_nowait
      if byte[ptr] == "0"       ' Run at location 0
        runmode |= sys#run_at_address0
      elseif byte[ptr] == "c"       ' Run C program at location 0
        runmode |= sys#run_c_program
    else
      long[argv][argc1++] := argv[i]

  ' Check if redirecting and killing shell or stand-alone or no wait
  if redirectin or redirectout
    if runmode & (sys#run_kill_caller | sys#run_stand_alone | sys#run_shell_nowait)
      c.printf0(string("Cannot redirect stdio with this run mode\n"))
      argc1 := 0

  return argc1

PUB run(fname, argc, pargv, mode) | cognum, entryptr, outfile
  'c.printf1(string("runmode = %2.2x\n"), runmode)
  mode |= cogid
  if mode & (sys#run_kill_caller | sys#run_stand_alone)
    if mode & sys#run_stand_alone
      save_sysparm
      outfile := c.fopen(string("/tmp/__reboot"), string("w"))
      if outfile
        c.fclose(outfile)
    SaveState
    outfile := c.fopen(string("/tmp/_restart.spl"), string("w"))
    if outfile
      'if mode & $08
      '  c.fprintf0(outfile, string("#standalone\n"))
      c.fprintf1(outfile, string("config %x\n"), long[sys#config])
      c.getcwd(strptr, 50)
      c.fprintf1(outfile, string("cd %s\n"), strptr)
      c.fprintf1(outfile, string("setlev %d\n"), shell_level)
      'PrintAlias(outfile)
      'if scriptfile
        'c.fprintf2(outfile, string("%s %d\n"), @scriptname, scriptline)
      c.fclose(outfile)
  long[pargv] := fname
  if mode & sys#run_c_program
    'c.printf0(string("shell: calling runc\n"))
    cognum := c.runc(argc, pargv, mode)
  else
    cognum := c.run(argc, pargv, mode)
  if cognum < 0
    return cognum
  entryptr := sys#cogtable + (cognum * 24)
  ifnot (mode & sys#run_shell_nowait)
    repeat while byte[entryptr]

pub load_sysparm | infile, ptr
  infile := c.fopen(string("/_sysparm"), string("r"))
  ifnot infile
    c.printf0(string("Could not open _sysparm\n"))
    return
  ptr := sys#unixtime
  repeat 3
    ifnot c.fgets(@buffer, 100, infile)
      quit
    c.sscanf1(@buffer, string("%d"), ptr)
    'c.printf2(string("Location $%4.4x = %d\n"), ptr, long[ptr])
    ptr += 4
  c.fclose(infile)

pub save_sysparm | outfile, ptr
  outfile := c.fopen(string("/_sysparm"), string("w"))
  ptr := sys#unixtime
  repeat 3
    c.fprintf1(outfile, string("%d\n"), long[ptr])
    ptr += 4
  c.fclose(outfile)

pub WriteHistory | outfile, ptr
  ptr := vs.SkipChar(@buffer, " ")
  if byte[ptr]
    if (outfile := c.fopen(string("/_history"), string("a")))
      c.fprintf1(outfile, string("%s\n"), @buffer)
      c.fclose(outfile)

