'**********************************************
'* Spin code generated by cspin version 0.68 *
'**********************************************


CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

  MAX_OBJECTS = 20

OBJ
  c : "clibsd"
  strsub : "strsubs"

PUB start(argc, argv)
  c.enter
  strsub.start
  main(argc, argv)
  waitcnt(clkfreq/10+cnt)
  c.exit(0)

DAT
  debugflag long 0

PUB usage
  c.printf0(string("usage: splink file1 file2 file3 [-d]\n"))
  c.exit(1)

PUB OpenFile(fname, mode) | fileptr
  fileptr := c.fopen(fname, mode)
  if (not fileptr)
    c.printf1(string("Could not open %s\n"), fname)
    c.exit(1)
  return fileptr

VAR
  long topmets
  long topobjs
  long numobjs

DAT
  offset long 0

VAR
  word objoffs[MAX_OBJECTS]

CON
' typedef struct SpinHeaderS
clockfreq = 0
mode_0 = 4
checksum = 8
pbase = 12
vbase = 16
dbase = 20
pcurr = 24
dcurr = 28

VAR
  word buf[512]
  long header1[8]
  long header2[8]

PUB PrintHeader(header)
  c.printf3(string("clkfreq = %d, mode = %d, checksum = %d\n"), long[header + clockfreq], long[header + mode_0], long[header + checksum])
  c.printf5(string("pbase = %d, vbase = %d, dbase = %d, pcurr = %d, dcurr = %d\n"), long[header + pbase], long[header + vbase], long[header + dbase], long[header + pcurr], long[header + dcurr])

PUB GetSpinHeader(infile, header) | buf_0[4]
  c.fread(@buf_0, 1, 16, infile)
  long[header + clockfreq] := buf_0[0]
  long[header + mode_0] := buf_0[1] & 255
  long[header + checksum] :=(buf_0[1] >> 8) & 255
  long[header + pbase] := buf_0[1] >> 16
  long[header + vbase] := buf_0[2] & $ffff
  long[header + dbase] := buf_0[2] >> 16
  long[header + pcurr] := buf_0[3] & $ffff
  long[header + dcurr] := buf_0[3] >> 16
  if (debugflag)
    PrintHeader(header)

PUB ComputeCheckSum(ptr, num) | i, checksum_0
  checksum_0 := 0
  i := 0
  repeat while (i < num)
    checksum_0 += byte[ptr++]
    i++
  return checksum_0 & 255

PUB WriteHeader(outfile, header) | buf_0[4]
  word[@buf_0][0] := long[header + clockfreq]
  word[@buf_0][1] := long[header + clockfreq] >> 16
  word[@buf_0][2] :=(long[header + checksum] << 8) | long[header + mode_0]
  word[@buf_0][3] := long[header + pbase]
  word[@buf_0][4] := long[header + vbase]
  word[@buf_0][5] := long[header + dbase]
  word[@buf_0][6] := long[header + pcurr]
  word[@buf_0][7] := long[header + dcurr]
  c.fwrite(@buf_0, 1, 16, outfile)

PUB CopyFile(infile, outfile, linkflag) | i, j, num
  repeat while ((num := c.fread(@buf, 1, 512, infile)) > 0)
    if (linkflag)
      linkflag := 0
      i := buf[1] & 255
      if (debugflag)
        c.printf1(string("CopyFile: %d methods\n"), i)
      j := 0
      repeat while (j < topobjs)
        if (debugflag)
          c.printf2(string("CopyFile: Change %d to %d\n"), buf[i << 1], objoffs[j])
        buf[i << 1] := objoffs[j]
        i++
        j++
      if (debugflag)
        i := 0
        repeat while (i < 14)
          c.printf1(string("%4.4x "), buf[i])
          i++
        c.printf0(string("\n"))
    c.fwrite(@buf, 1, num, outfile)

PUB GetObjectInfo(infile, top) | objnum, num, nummet, numobj, objsize
  objnum := 0
  repeat while ((num := c.fread(@buf, 1, 4, infile)) > 0)
    nummet := buf[1] & 255
    numobj := buf[1] >> 8
    objsize := buf[0]
    if (debugflag)
      c.printf5(string("GetObjInfo: obj %3d, methods = %3d, objects = %3d, size = %5d, offset = %5d\n"), objnum, nummet, numobj, objsize, offset)
    objnum++
    if (top)
      if (objnum > 1)
        c.printf0(string("Top object contains more than one object\n"))
        c.exit(1)
      topmets := nummet
      topobjs := numobj
    else
      if (objnum > MAX_OBJECTS)
        c.printf0(string("Too many objects\n"))
        c.exit(1)
      numobjs := objnum
      objoffs[objnum - 1] := offset
    offset += objsize
    objsize -= 4
    repeat while (objsize > 0)
      num := 512
      if (objsize < 512)
        num := objsize
      num := c.fread(@buf, 1, num, infile)
      if (num =< 0)
        c.printf0(string("Object too small\n"))
        c.exit(1)
      objsize -= num
  c.fseek(infile, 16, c#SEEK_SET)

PUB main(argc, argv) | i, infile1, infile2, outfile, psize1, psize2, vsize2, checksum_old, checksum_new
  if (argc == 5 and not c.strcmp(long[argv][4], string("-d")))
    debugflag := 1
  elseif (argc <> 4)
    usage
  infile1 := OpenFile(long[argv][1], string("r"))
  infile2 := OpenFile(long[argv][2], string("r"))
  outfile := OpenFile(long[argv][3], string("w"))
  GetSpinHeader(infile1, @header1)
  GetSpinHeader(infile2, @header2)
  checksum_old := ComputeCheckSum(@header1, 32) - $14
  checksum_old += ComputeCheckSum(@header2, 32) - $14
  checksum_old &= 255
  if (debugflag)
    c.printf1(string("Header checksum = %d\n"), checksum_old)
  psize1 := long[@header1 + vbase] - long[@header1 + pbase]
  psize2 := long[@header2 + vbase] - long[@header2 + pbase]
  vsize2 := long[@header2 + dbase] - long[@header2 + vbase] - 8
  if (debugflag)
    c.printf2(string("psize2 = %d, vsize2 = %d\n"), psize2, vsize2)
    c.printf1(string("psize1 %d\n"), psize1)
  long[@header1 + vbase] += psize2
  long[@header1 + dbase] += psize2 + vsize2
  long[@header1 + dcurr] += psize2 + vsize2
  GetObjectInfo(infile1, 1)
  GetObjectInfo(infile2, 0)
  checksum_new := ComputeCheckSum(@header1, 32)
  if (debugflag)
    c.printf1(string("New checksum = %d\n"), checksum_new)
  ' Update the checksum
  i := 0
  repeat while (i < topobjs)
    checksum_new += ComputeCheckSum(@objoffs[i], 2)
    i++
  long[@header1 + checksum] :=(long[@header1 + checksum] -(checksum_new - checksum_old) + $14) & 255
  if (debugflag)
    PrintHeader(@header1)
  WriteHeader(outfile, @header1)
  CopyFile(infile1, outfile, 1)
  CopyFile(infile2, outfile, 0)
  c.fclose(infile1)
  c.fclose(infile2)
  c.fclose(outfile)
  return 0
