'******************************************************************************
' Copyright (c) 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c : "clibsd"

PUB main(argc, argv) | infile, outfile, numlines, totlines, ptr, buffer[25]

  c.enter

  infile := 0
  numlines := 10
  ptr := long[argv][1]

  ' Parse the command-line arguments
  if argc < 2
    infile := c.getstdin
  elseif argc > 3
    usage
  elseif byte[ptr] == "-"
    ifnot c.isdigit(byte[++ptr])
      usage
    c.sscanf1(ptr, string("%d"), @numlines)
    if numlines =< 0
      usage
    if argc == 2
      infile := c.getstdin
    else
      ptr := long[argv][2]
  elseif argc == 2
    ptr := long[argv][1]
  else
    usage

  ' Return if stdin selected
  if infile
    c.exit(0)

  ' Open the input file if not stdin
  infile := c.fopen(ptr, string("r"))
  if (infile == 0)
    c.printf1(string("Error opening %s\n"), ptr)
    c.exit(0)

  outfile := c.getstdout

  ' Count the number of lines in the file
  totlines := 0
  repeat while c.fgets(@buffer, 100, infile) > 0
    totlines++

  ' Rewind the input file and skip the (totlines - numlines) lines
  c.fseek(infile, 0, c#SEEK_SET)
  if totlines > numlines
    repeat totlines - numlines
      c.fgets(@buffer, 100, infile)

  ' Print the tail
  repeat numlines
    if c.fgets(@buffer, 100, infile) =< 0
      quit
    c.fputs(@buffer, outfile)

  if (infile <> c.getstdin)
    c.fclose(infile)
  c.exit(0)

PUB usage
  c.printf0(string("usage: tail [-n] file\n"))
  c.exit(0)

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
