'**********************************************
'* Spin code generated by cspin version 0.060 *
'**********************************************
'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************

CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c : "clibsd"

CON
  NAME = 0
  MODE = 100
  OWNER = 108
  GROUP = 116
  SIZE = 124
  TIME = 136
  CHECKSUM = 148
  FILETYPE = 156
  LINKEDFILE = 157

DAT
  buffer byte 0[512]

PUB main(argc, argv)
  c.enter
  if (argc < 3)
    usage
  if (c.strcmp(long[argv][1], string("-xf")) == 0)
    extract(argc, argv)
  elseif (c.strcmp(long[argv][1], string("-cf")) == 0)
    create(argc, argv)
  else
    c.exit(1)
  c.exit(0)
  
PUB usage
  c.printf0(string("usage: tar [flags] tarfile [filelist]\n"))
  c.printf0(string("         -xf Extract files from tarfile\n"))
  c.printf0(string("         -cf Create tarfile and add files\n"))
  c.exit(0)

PUB create(argc, argv) | infile, outfile, i, num, filesize, checksum_0, argi
  outfile := c.fopen(long[argv][2], string("w"))
  if (not outfile)
    c.printf1(string("Could not create tarfile %s\n"), long[argv][2])
    return 1
  argi := 3
  repeat while (argi < argc)
    infile := c.fopen(long[argv][argi], string("r"))
    if (infile == 0)
      c.printf1(string("Could not open input file %s\n"), long[argv][argi])
      'continue;
    c.memset(@buffer, 0, 512)
    c.strcpy(@buffer, long[argv][argi])
    c.strcpy(@buffer[MODE], string("0000666"))
    c.strcpy(@buffer[OWNER], string("0001370"))
    c.strcpy(@buffer[GROUP], string("0000765"))
    c.fseek(infile, 0, c#SEEK_END)
    filesize := c.ftell(infile)
    c.fseek(infile, 0, c#SEEK_SET)
    c.sprintf1(@buffer[SIZE], string("%011o"), filesize)
    c.strcpy(@buffer[TIME], string("11374320374"))
    buffer[FILETYPE] := "0"
    'checksum = 1718 + buffer[FILETYPE];
    checksum_0 := 256
    i := 0
    repeat while (i < CHECKSUM)
      checksum_0 += buffer[i]
      i++
    i := FILETYPE
    repeat while (i < 512)
      checksum_0 += buffer[i]
      i++
    buffer[CHECKSUM + 7] := " "
    c.sprintf1(@buffer[CHECKSUM], string("%06o"), checksum_0)
    c.fwrite(@buffer, 1, 512, outfile)
    repeat while (filesize > 0)
      num := c.fread(@buffer, 1, 512, infile)
      if (num =< 0)
        quit
      if (num < 512)
        c.memset(@buffer[num], 0, 512 - num)
      c.fwrite(@buffer, 1, 512, outfile)
      filesize -= 512
    c.fclose(infile)
    argi++
  c.memset(@buffer, 0, 512)
  c.fwrite(@buffer, 1, 512, outfile)
  c.fwrite(@buffer, 1, 512, outfile)
  c.fclose(outfile)

PUB extract(argc, argv) | i, num, blocknum, infile, outfile, skipcount, filesize, checksum_0, attributes
  blocknum := 0
  skipcount := 0
  checksum_0 := 0
  infile := c.fopen(long[argv][2], string("r"))
  if (infile == 0)
    c.printf0(string("Could not open input file\n"))
    return 1
  repeat while (1)
    if (c.fread(@buffer, 1, 512, infile) <> 512)
      quit
    'if (skipcount-- > 0) continue;
    i := 0
    repeat while (i < 512)
      if (buffer[i])
        quit
      i++
    if (i == 512)
      quit
    c.sscanf1(@buffer[CHECKSUM], string("%o"), @checksum_0)
    'checksum = 1718 + buffer[FILETYPE] - checksum;
    checksum_0 := 256 - checksum_0
    i := 0
    repeat while (i < CHECKSUM)
      checksum_0 += buffer[i]
      i++
    i := FILETYPE
    repeat while (i < 512)
      checksum_0 += buffer[i]
      i++
    'printf("checksum = %o", checksum);
    c.sscanf1(@buffer[SIZE], string("%o"), @filesize)
    c.sscanf1(@buffer[MODE], string("%o"), @attributes)
    c.printf4(string("filename = %s, filesize = %d, attributes = %o, checksum = %d\n"), @buffer, filesize, attributes, checksum_0)
    skipcount :=(filesize + 511) >> 9
    if (checksum_0)
      c.printf0(string("Checksum error\n"))
      return 1
    outfile := c.fopen(@buffer, string("w"))
    if (not outfile)
      c.printf1(string("Could not open output file %s\n"), @buffer)
      return 1
    repeat while (filesize > 0)
      num := c.fread(@buffer, 1, 512, infile)
      if (num <> 512)
        c.printf0(string("Encountered EOF on tar file\n"))
        return 1
      num := 512
      if (filesize < num)
        num := filesize
      c.fwrite(@buffer, 1, num, outfile)
      filesize -= 512
    c.fclose(outfile)
  c.fclose(infile)

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
