'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c   : "clibsd"
  ser : "cserial"
  run : "runprog"
  sys : "sysdefs"
  f   : "fsrwx"

DAT
  nullstr byte 0[4]
  tokens long 0[20]
  buffer byte 0[100]

PUB main(argc, argv) | infile, stream, handle, num, sector, size, i
  c.enter
  repeat
    c.printf0(string("$ "))
    c.gets(@buffer)
    num := tokenize
    ifnot num
      next
    repeat i from 0 to num-1
      c.printf1(string("<%s> "), tokens[i])
    c.printf0(string("\n"))
    infile := c.fopen(tokens[0], string("r"))
    ifnot infile
      c.printf1(string("Could not open %s\n"), tokens[0])
      next
    handle := long[infile][c#stream_handle]
    sector := f.hget_first_sector(handle)
    size := f.hget_filesize(handle)
    c.fclose(infile)
    runit(num, @tokens, sector, size)

PUB runit(argc, argv, sector, size) | stream, handle
  long[argv][argc] := @nullstr
  long[argv][argc+1] := @nullstr
  copyargs(argc+2, argv)
  stream := c.getstdin
  handle := long[stream][c#stream_handle]
  ser.stop1(handle)
  run.run(argc, sys#argv_parms, sector, size)

PUB copyargs(argc, argv) | i, ptr1, ptr2
  if argc > 0
    ptr1 := sys#argv_parms
    ptr2 := ptr1 + argc * 4
    repeat i from 0 to argc + 1
      long[ptr1][i] := ptr2
      c.strcpy(ptr2, long[argv][i])
      ptr2 += strsize(long[argv][i]) + 1

PUB tokenize | ptr
  ptr := @buffer
  repeat while byte[ptr]
    ptr := SkipChar(ptr, " ")
    ifnot byte[ptr]
      quit
    tokens[result++] := ptr
    ptr := FindChar(ptr, " ")
    if byte[ptr]
      byte[ptr++] := 0

PUB FindChar(ptr, val)
  repeat while byte[ptr]
    if byte[ptr] == val
      quit
    ptr++
  return ptr

PUB SkipChar(ptr, val)
  repeat while byte[ptr]
    if byte[ptr] <> val
      quit
    ptr++
  return ptr

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}

