'******************************************************************************
' Copyright (c)  2013 Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c : "clibsd"
  vs : "varsubs"

PUB main(argc, argv)
  c.enter
  result := (evaluate(argc-1, argv+4) == 0) & 1
  c.exit(result)

PUB evaluate(argc, argv)
  if argc == 1 and strcomp(long[argv], string("-z"))
    return 1
  if argc == 2
    return eval2(argv)
  if argc == 3
    return eval3(argv)
  return 0

PUB eval2(argv) | operator, operand
  operator := long[argv]
  operand  := long[argv][1]
  if strcomp(operator, string("-n"))
    return 1
  if strcomp(operator, string("-f"))
    return IsFile(operand)
  if strcomp(operator, string("-d"))
    return IsDir(operand)
  if strcomp(operator, string("-e"))
    return Exists(operand)

PUB eval3(argv) | operator, operand1, operand2, value1, value2
  operand1 := long[argv]
  operator := long[argv][1]
  operand2 := long[argv][2]

  ' Check for string comparisons
  if strcomp(operator, string("=")) or strcomp(operator, string("=="))
    return strcomp(operand1, operand2)
  if strcomp(operator, string("!="))
    return not strcomp(operand1, operand2)
  if strcomp(operator, string("<"))
    return c.strcmp(operand1, operand2) < 0
  if strcomp(operator, string(">"))
    return c.strcmp(operand1, operand2) > 0

  ' Check for numerical comparisons
  value1 := atol(operand1)
  value2 := atol(operand2)
  if strcomp(operator, string("-eq"))
    return value1 == value2
  if strcomp(operator, string("-ne"))
    return value1 <> value2
  if strcomp(operator, string("-gt"))
    return value1 >  value2
  if strcomp(operator, string("-ge"))
    return value1 => value2
  if strcomp(operator, string("-lt"))
    return value1 <  value2
  if strcomp(operator, string("-le"))
    return value1 =< value2

PUB IsFile(name) | stream
  if (stream := c.fopen(name, string("r")))
    c.fclose(stream)
    return 1

PUB IsDir(name) | stream
  if (stream := c.opendir(name))
    c.closedir(stream)
    return 1

PUB Exists(name)
  if IsFile(name)
    return 1
  if IsDir(name)
    return 1

PUB atol(ptr)
  c.sscanf1(ptr, string("%d"), @result)

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
