'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c : "clibsd"

DAT
  buffer long 0[50]

PUB main(argc, argv) | infile, outfile, len, ptr

  c.enter

  if argc <> 2
    c.printf0(string("usage: unix2dos file\n"))
    c.exit(1)

  ' Copy file to temporary file and remove CR
  infile := c.fopen(long[argv][1], string("r"))
  ifnot infile
    c.printf1(string("Could not open %s\n"), long[argv][1])
    c.exit(1)

  outfile := c.fopen(string("_temp123.tmp"), string("w"))
  ifnot outfile
    c.fclose(infile)
    c.printf0(string("Could not open temporary file\n"))
    c.exit(1)

  repeat while c.fgets(@buffer, 197, infile)
    len := strsize(@buffer)
    ptr := @buffer + len - 1
    if len and byte[ptr] == 10
      len--
      ptr--
    if len and byte[ptr] == 13
      len--
      ptr--
    byte[ptr][1] := 13
    byte[ptr][2] := 10
    byte[ptr][3] := 0
    c.fputs(@buffer, outfile)

  c.fclose(infile)
  c.fclose(outfile)

  ' Copy temporary file to file
  infile := c.fopen(string("_temp123.tmp"), string("r"))
  ifnot infile
    c.printf0(string("Could not open temporary file\n"))
    c.exit(1)

  outfile := c.fopen(long[argv][1], string("w"))
  ifnot outfile
    c.fclose(infile)
    c.printf1(string("Could not open %s\n"), long[argv][1])
    c.exit(1)

  repeat while (len := c.fread(@buffer, 1, 200, infile)) > 0
    c.fwrite(@buffer, 1, len, outfile)

  c.fclose(infile)
  c.fclose(outfile)

  c.remove(string("_temp123.tmp"))
  c.exit(0)

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
