PUB unix_time(yr, mo, da, hr, mn, sec, timezone) | a, days
  if (mo < 3)
    yr--
    mo += 12
  a := yr / 100
  days := (36525 * yr) / 100 + 306001 * (mo + 1) / 10000 + da - a + a ~> 2 - 719591
  return days * 86400 + (hr - timezone) * 3600 + mn * 60 + sec

PUB date(unixtime, timezone) | yyyymmdd, year, month, day, leap
  day := floor_div(unixtime + timezone * 3600, 86400)
  year := floor_div(day << 2 + 2, 1461)
  word[@yyyymmdd][1] := year + 1970
  leap := floor_mod(year, 4) == 2
  day -= (year * 1461 + 1) ~> 2
  if (day > 58 - leap)
    day += leap + 2
  byte[@yyyymmdd][1] := (day * 12 + 6) / 367
  byte[@yyyymmdd][0] := day + 1 - (byte[@yyyymmdd][1]++ * 367 + 5) / 12
  return yyyymmdd

PUB time(unixtime, timezone) | hours, minutes, seconds
  seconds := floor_mod(unixtime + timezone * 3600, 86400)
  minutes := seconds / 60
  seconds -= minutes * 60
  hours := minutes / 60
  minutes -= hours * 60
  return hours << 16 + minutes << 8 + seconds

PUB weekday(unixtime, timezone)
  return floor_mod(floor_div(unixtime + timezone * 3600, 86400) + 4, 7)

PUB floor_div(numer, denom)
  if (numer < 0)
    numer -= denom - 1
  return numer / denom

PUB floor_mod(numer, denom)
  result := numer // denom
  if (result < 0)
    result += denom

