'******************************************************************************
' Copyright (c) 2013 Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  GLOBAL_FLAG = "G"
  LOCAL_FLAG  = "L"
  PARM_FLAG   = "P"
  ALIAS_FLAG  = "A"

DAT
  nullstr long 0
  retvalstr long 0[4]

OBJ
  dbg : "cserial"
  sys : "sysdefs"

PUB FindVar(str) | ptr
  ptr := sys#environ_vars
  repeat while byte[ptr]
    if strcomp(str, ptr+1)
      if byte[ptr] <> ALIAS_FLAG
        return ptr
    ptr += strsize(ptr) + 1
    ptr += strsize(ptr) + 1

PUB FindAlias(str) | ptr
  ptr := sys#environ_vars
  repeat while byte[ptr]
    if strcomp(str, ptr+1)
      if byte[ptr] == ALIAS_FLAG
        return ptr
    ptr += strsize(ptr) + 1
    ptr += strsize(ptr) + 1

PUB FindEnd | ptr
  ptr := sys#environ_vars
  repeat while byte[ptr]
    ptr += strsize(ptr) + 1
    ptr += strsize(ptr) + 1
  return ptr

PUB RemoveEntry(ptr1) | ptr2, len
  ptr2 := ptr1 + strsize(ptr1) + 1
  ptr2 += strsize(ptr2) + 1
  repeat while byte[ptr2]
    repeat 2
      len := strsize(ptr2) + 1
      bytemove(ptr1, ptr2, len)
      ptr1 += len
      ptr2 += len
  byte[ptr1] := 0
  return ptr1

PUB RemoveVar(name) | ptr
  if (ptr := FindVar(name))
    ptr := RemoveEntry(ptr)

PUB SaveVar(name, value, type) | ptr, space, len1, len2

  ' Check if variable already exists
  if (ptr := FindVar(name))
    type := byte[ptr]
    ptr := RemoveEntry(ptr)
  else
    ptr := FindEnd

  ' Check if space is available
  space := sys#environ_vars_end - ptr + 1
  len1 := strsize(name) + 1
  len2 := strsize(value) + 1
  if (space < len1 + len2 + 2)
    dbg.dbprintf0(string("Not enough variable space\n"))
    return
  elseif (space < len1 + len2 + 52)
    dbg.dbprintf2(string("space = %d, need = %d\n"), space, len1 + len2 + 2)

  ' Add variable
  byte[ptr++] := type
  bytemove(ptr, name, len1)
  ptr += len1
  bytemove(ptr, value, len2)
  ptr += len2
  byte[ptr] := 0

PUB GetVarVal(name) | ptr
  if strcomp(name, string("?"))
    itoa(long[sys#return_value], @retvalstr)
    'dbg.dbprintf2(string("GetVarVal($?) %d %s\n"), long[sys#return_value], @retvalstr)
    return @retvalstr
  if (ptr := FindVar(name))
    return ptr + strsize(ptr) + 1
  return @nullstr

PUB Val_0(ptr)
  if (byte[ptr][0] <> "$")
    return ptr
  return GetVarVal(@byte[ptr][1])

PUB NumVal(ptr)
  if (byte[ptr][0] == "$")
    if strcomp(ptr, string("$?"))
      return long[sys#return_value]
    ptr := GetVarVal(@byte[ptr][1])
  return atol(ptr)

PUB FindChar(str, val)
  repeat while byte[str]
    if byte[str] == val
      quit
    str++
  return str

PUB SkipChar(str, val)
  repeat while byte[str]
    if byte[str] <> val
      quit
    str++
  return str

PUB IsAlpha(val)
  return ((val => "A" and val =< "Z") or (val => "a" and val =< "z"))

PUB atol(ptr) | signflag
  signflag := (byte[ptr] == "-")
  ptr -= signflag
  repeat while byte[ptr] => "0" and byte[ptr] =< "9"
    result := (result * 10) + byte[ptr++] - "0"
  if signflag
    result := -result

PUB itoa(val, str) | divisor, flag
  if val < 0
    byte[str++] := "-"
    val := -val
  flag := 0
  divisor := 1_000_000_000
  repeat 9
    result := val / divisor
    val //= divisor
    divisor /= 10
    if result or flag
      flag := 1
      byte[str++] := result + "0"
  byte[str++] := val + "0"
  byte[str] := 0

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
