'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c    : "clibsd"
  vga  : "vgatext"
  vgap : "vgatextp"

DAT
  c3_flag long 0
  base_pin long 0
  vga_struct long 0[vgap#handlesize]

PUB main(argc, argv) | i, handle, vga_cog
  c.enter
  ProcessParm(argc, argv)
  if c3_flag
    DIRA |= $8000
  handle := @vga_struct
  vga_cog := vgap.start(handle, base_pin)
  ifnot vga_cog
    c.printf0(string("VGA driver is not loaded\n"))
    exit(1)

  'start term
  vga.str(handle, string(13,"   VGA Text Demo...",13,13,$C,5," OBJ and VAR require only 2.6KB ",$C,1))
  repeat 14
    vga.out(handle, " ")
  repeat i from $0E to $FF
    vga.out(handle, i)
  vga.str(handle, string($C,6,"     Uses internal ROM font     ",$C,2))
  c.getchar
  vga.out(handle, $c)
  vga.out(handle, 0)
  vga.out(handle, 0)
  repeat
    result := c.getchar
    if result == 3 or result == 27
      quit
    c.putchar(result)
    vga.out(handle, result)

  exit(0)

PUB ProcessParm(argc, argv) | ptr

  'check for two parms
  if argc <> 2 
    usage

  ' Check if arg is c3 or C3
  ptr := long[argv][1]
  if strcomp(ptr, string("c3")) or strcomp(ptr, string("C3"))
    base_pin := 16
  ' else, check if it's 0, 8, 16 or 24
  else
    c.sscanf1(ptr, string("%d"), @base_pin)
    if base_pin <> 0 and base_pin <> 8 and base_pin <> 16 and base_pin <> 24
      usage

PRI usage
  c.printf0(string("usage: vgatdemo parm\n"))
  c.printf0(string("    parm is either 'c3' for the C3 board or\n"))
  c.printf0(string("    a starting pin number of 0, 8, 16 or 24\n"))
  waitcnt(cnt + clkfreq/10)
  exit(1)

PRI exit(retval)
  if c3_flag
    DIRA &= !$8000
  c.exit(retval)

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}

