''***************************************
''*  VGA Text 32x15 v1.0                *
''*  Author: Chip Gracey                *
''*  Copyright (c) 2006 Parallax, Inc.  *
''*  See end of file for terms of use.  *
''*  Modified by Dave Hein for spinix   *
''***************************************

CON

  cols = 32
  rows = 15

  screensize = cols * rows
  lastrow = screensize - cols

  s_vga_screen = 4
  s_vga_colors = 5
  s_vga_col    = 21
  s_vga_row    = 22
  s_vga_color  = 23

DAT
  flag  long 0

PUB str(handle, stringptr)

'' Print a zero-terminated string

  repeat strsize(stringptr)
    out(handle, byte[stringptr++])


PUB out(handle, c) | i, k, pscreen, col, row, color

'' Output a character
''
''     $00 = clear screen
''     $01 = home
''     $08 = backspace
''     $09 = tab (8 spaces per)
''     $0A = set X position (X follows)
''     $0B = set Y position (Y follows)
''     $0C = set color (color follows)
''     $0D = return
''  others = printable characters

  pscreen := long[handle][s_vga_screen]
  col := long[handle][s_vga_col]
  row := long[handle][s_vga_row]

  case flag
    $00: case c
           $00: wordfill(pscreen, $220, screensize)
                col := row := 0
           $01: col := row := 0
           $08: if col
                  col--
           $09: repeat
                  print(handle, " ")
                while (col++) & 7
                return
           $0A..$0C: flag := c
                     return
           $0D: newline(handle)
                return
           other: print(handle, c)
                  return
    $0A: col := c // cols
    $0B: row := c // rows
    $0C: color := c & 7
         long[handle][s_vga_color] := color
         flag := 0
         return
  flag := 0

  long[handle][s_vga_col] := col
  long[handle][s_vga_row] := row


PUB setcolors(handle, colorptr) | i, fore, back, pcolors

'' Override default color palette
'' colorptr must point to a list of up to 8 colors
'' arranged as follows (where r, g, b are 0..3):
''
''               fore   back
''               ------------
'' palette  byte %%rgb, %%rgb     'color 0
''          byte %%rgb, %%rgb     'color 1
''          byte %%rgb, %%rgb     'color 2
''          ...

  pcolors := long[handle][s_vga_colors]

  repeat i from 0 to 7
    fore := byte[colorptr][i << 1] << 2
    back := byte[colorptr][i << 1 + 1] << 2
    long[pcolors][i << 1]     := fore << 24 + back << 16 + fore << 8 + back
    long[pcolors][i << 1 + 1] := fore << 24 + fore << 16 + back << 8 + back


PRI print(handle, c) | pscreen, col, row, color

  pscreen := long[handle][s_vga_screen]
  col := long[handle][s_vga_col]
  row := long[handle][s_vga_row]
  color := long[handle][s_vga_color]

  if col == cols - 1
    c := ">"

  word[pscreen][row * cols + col] := (color << 1 + c & 1) << 10 + $200 + c & $FE
  if col < cols - 1
    if ++col == cols
      newline(handle)
    else
      long[handle][s_vga_col] := col


PUB newline(handle) | i, pscreen, col, row

  pscreen := long[handle][s_vga_screen]
  row := long[handle][s_vga_row]

  col := 0
  if ++row == rows
    row--
    wordmove(pscreen, pscreen + cols*2, lastrow)   'scroll lines
    wordfill(pscreen + lastrow*2, $220, cols)      'clear new line

  long[handle][s_vga_col] := col
  long[handle][s_vga_row] := row



{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}                        
