'**********************************************
'* Spin code generated by cspin version 0.066 *
'**********************************************

CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c : "clibsd"

PUB start(argc, argv) | config
  c.enter
  config := c.getconfig
  termtype := (config >> 4) & 3
  result := (config >> 8) & $ff
  if result > 1
    vlines := result - 1
  main(argc, argv)

'******************************************************************************
' ED Text Editor
' Copyright (c) 2011, Dave Hein
' See end of file for terms of use.
'******************************************************************************

CON
  HDR_SIZE = 8
' typedef struct StringS
next_0 = 0
size = 4
str = 8
  UNSPECIFIED = - 2
  PARSING_ERROR = - 3
  TAB_CHAR = 9
  MAX_CHARS = 200
  MALLOC_SIZE = 16000
  CHANGE_ONE_LINE = 2
  CHANGE_TWO_LINES_UP = 3
  CHANGE_TWO_LINES_DOWN = 4
  CHANGE_CURSOR_POSITION = 5
' Uninitialized global variables

VAR
  long memorysize
  long ListHead
  long YankHead
  byte srchstr[100]
  byte rplcstr1[100]
  byte rplcstr2[100]
  byte filename[100]
  byte inbuf[MAX_CHARS]
' Initialized global variables

DAT
  rflag long 0
  gflag long 0
  vmode long 1
  prompt long 0
  vlines long 21
  scroll long 20
  changed long 0
  numlines long 0
  currline long 0
  currcol long 1
  dispcol long 1
  retcode long 0
  cmd0 long 0
  count long 0
  schange long 1
  topline long 1
  termtype long 0
  stdout long 0
  statuslen long 0
  srchdir long 1
  lastcmd long 0
  lastcnt long 0
  lastval long 0
  nullstr byte 0
' Main program entry

PUB main(argc, argv) | cmd, strbuf
  stdout := c.getstdout
  'argc := 1
  ' Initialization
  srchstr[0] := 0
  rplcstr1[0] := 0
  rplcstr2[0] := 0
  ListHead := 0
  YankHead := 0
  prompt := ":"
  ' Allocate space for file
  result := c.malloc(600)
  ' Allocate the string buffer
  memorysize := MALLOC_SIZE
  repeat while (memorysize > 0)
    strbuf := c.malloc(memorysize)
    if (strbuf)
      quit
    memorysize -= 1000
  c.free(result)
  smallocinit(strbuf, memorysize)
  'c.printf1(string("memorysize = %d\n"), memorysize)
  ' Copy the input file name if specified
  if (argc > 1)
    c.strcpy(@filename, long[argv][1])
  else
    filename[0] := 0
  currline := ReadFile(@filename, 0)
  'c.printf0(string("Press a key\n"))
  'c.getchar
  if (numlines > 0)
    currline := 1
  ' Get a command and execute it
  repeat while (1)
    gflag := 0
    CheckMemory
    if (vmode == 1)
      if (schange)
        PrintScreen(currline)
        schange := 0
      cmd := c.getchar
      ExecuteViCommand(cmd)
    else
      if (prompt)
        c.printf1(string("%c"), prompt)
      c.gets(@inbuf)
      retcode := ExecuteCommand
      if (retcode > 0)
        quit
      elseif (retcode < 0)
        c.printf1(string("E%d:\n"), - retcode)
      if (vmode == - 1)
        vmode := 1
  c.free(strbuf)
  c.exit(0)

' Allocate a string link and copy contents of "str"

PUB AllocateString(str_0) | link
  link := smalloc(strsize(str_0) + 1)
  if (link)
    c.strcpy((link + str), str_0)
  return link
' Duplicate a string link

PUB DuplicateString(link)
  return AllocateString((link + str))
' Check for a memory leak

PUB CheckMemory | total, curr, listsize, yanksize, freesize
  listsize := 0
  yanksize := 0
  freesize := 0
  curr := ListHead
  repeat while (curr)
    listsize += long[curr + size]
    curr := long[curr + next_0]
  curr := YankHead
  repeat while (curr)
    yanksize += long[curr + size]
    curr := long[curr + next_0]
  curr := smfreelist
  repeat while (curr)
    freesize += long[curr + size]
    curr := long[curr + next_0]
  total := listsize + yanksize + freesize
  if (total <> memorysize)
    c.printf0(string("Memory leak!\n"))
    c.printf4(string("listsize = %d, yanksize = %d, freesize = %d, total = %d\n"), listsize, yanksize, freesize, listsize + yanksize + freesize)
' Get a pointer to a string link from its line number

PUB GetLinePtr(linenum, pprev) | prev, curr
  prev := 0
  curr := ListHead
  repeat while (curr and--linenum > 0)
    prev := curr
    curr := long[curr + next_0]
  long[pprev] := prev
  return curr
' Remove the CR and LF characters from the end of a line

PUB RemoveCRLF(str_0) | len
  len := strsize(str_0)
  str_0 += len - 1
  repeat while (len > 0)
    if (byte[str_0] <> 10 and byte[str_0] <> 13)
      quit
    byte[str_0--] := 0
    len--
' Insert a string link at the line given by "linenum"

PUB InsertLine(line, linenum) | prev, curr
  curr := GetLinePtr(linenum - 1, @prev)
  if (linenum < 1 or linenum > numlines + 1)
    c.printf2(string("InsertLine: linenum = %d, numlines = %d\n"), linenum, numlines)
  if (curr == 0 and(linenum <> 1 or ListHead <> 0))
    c.printf1(string("InsertLine: curr == 0, linenum = %d\n"), linenum)
  if (linenum == 1)
    long[line + next_0] := ListHead
    ListHead := line
  else
    long[line + next_0] := long[curr + next_0]
    long[curr + next_0] := line
  numlines++
' Delete the line at "linenum"

PUB DeleteLine(linenum) | prev, curr
  curr := GetLinePtr(linenum, @prev)
  if (not curr)
    c.printf1(string("DeleteLine: curr = 0, linenum = %d\n"), linenum)
    return
  if (not prev)
    ListHead := long[curr + next_0]
  else
    long[prev + next_0] := long[curr + next_0]
  sfree(curr)
  numlines--
' Based on the value of gflag, check for if the line
' at "lineptr" does, or does not contains "str"

PUB CheckMatch(lineptr, str_0)
  if (gflag == 0)
    return 0
  if (gflag == 1)
    if (not FindString(lineptr, str_0))
      return 1
    return 0
  if (FindString(lineptr, str_0))
    return 1
  return 0
' Print lines using the "n", "v", "l" or "p" format

PUB PrintLines(linenum, first, last, mode) | col, len, line, fflag, lastproc, LinePtr_0, prev, curr
  lastproc := linenum
  curr := GetLinePtr(first, @prev)
  line := first
  repeat while (line =< last)
    if (not curr)
      c.printf1(string("PrintLines: curr = 0, line = %s\n"), line)
      return 0
    LinePtr_0 :=(curr + str)
    curr := long[curr + next_0]
    if (CheckMatch(LinePtr_0, @srchstr))
      line++
      next
    if (mode == "n")
      c.printf2(string("%6d  %s\n"), line, LinePtr_0)
    elseif (mode == "v")
      if (line == linenum and termtype <> 2)
        len := strsize(LinePtr_0)
        col := 0
        repeat while (col < len)
          if (col + 1 <> dispcol)
            c.printf1(string("%c"), byte[LinePtr_0][col])
          else
            c.printf1(string("%c"), "@")
          col++
        if (dispcol > len)
          c.printf1(string("%c"), "@")
        c.printf0(string("\n"))
      else
        c.printf1(string("%s\n"), LinePtr_0)
    elseif (mode == "l")
      repeat while (byte[LinePtr_0])
        if (byte[LinePtr_0] => 32 and byte[LinePtr_0] < 127)
          c.printf1(string("%c"), byte[LinePtr_0])
        elseif (byte[LinePtr_0] == TAB_CHAR)
          c.printf0(string("\\t"))
        else
          c.printf1(string("\\x%2.2x"), byte[LinePtr_0])
        LinePtr_0++
      c.printf0(string("$\n"))
    else
      c.printf1(string("%s\n"), LinePtr_0)
    lastproc := line
    line++
  return lastproc
' Decode a number from the string

PUB getnum(pstr) | val, str_0
  val := 0
  str_0 := long[pstr]
  repeat while (c.isdigit(byte[str_0]))
    val :=(val * 10) + byte[str_0++] - "0"
  long[pstr] := str_0
  return val
' Find the next character that matches "val"

PUB FindChar(str_0, val)
  repeat while (byte[str_0])
    if (byte[str_0] == val)
      quit
    str_0++
  return str_0
' Skip the next character that does not match "val"

PUB SkipChar(str_0, val)
  repeat while (byte[str_0])
    if (byte[str_0] <> val)
      quit
    str_0++
  return str_0

' Return true if "str2" is found in "str1"
PUB FindString(str1, str2) | len, col
  col := 1
  len := strsize(str2)
  repeat while (byte[str1])
    if (c.strncmp(str1, str2, len) == 0)
      return col
    str1++
    col++
  return 0

' Return column if "str2" is found in "str1", otherwise return 0
PUB FindStringBackward(str1, str2, len1) | len2
  if len1 < 1
    return
  str1 += len1 - 1
  len2 := strsize(str2)
  repeat while len1
    if (c.strncmp(str1, str2, len2) == 0)
      return len1
    len1--
    str1--

' Use the first character as a delimeter and copy the string to srchstr
PUB GetString(pstr) | ptr, str_0, val, len
  str_0 := long[pstr]
  val := byte[str_0++]
  if (not val)
    return 0
  ptr := FindChar(str_0, val)
  len :=(ptr) -(str_0)
  if (byte[ptr])
    ptr++
  long[pstr] := ptr
  if (len > 0)
    c.memcpy(@srchstr, str_0, len)
    srchstr[len] := 0
  return 1
' Search forward through all the lines for the first occurance of srchstr

PUB SearchStringForward(pstr, linenum) | i, prev, curr
  curr := GetLinePtr(linenum + 1, @prev)
  if (not GetString(pstr))
    return PARSING_ERROR
  i := linenum + 1
  repeat while (i =< numlines)
    if (not curr)
      c.printf1(string("SearchStringForward: curr = 0, line = %d\n"), i)
      return - 3
    if (FindString((curr + str), @srchstr))
      return i
    curr := long[curr + next_0]
    i++
  curr := ListHead
  i := 1
  repeat while (i =< linenum)
    if (not curr)
      c.printf1(string("SearchStringForward: curr = 0, line = %d\n"), i)
      return - 3
    if (FindString((curr + str), @srchstr))
      return i
    curr := long[curr + next_0]
    i++
  return PARSING_ERROR
' Search backward through all the lines for the first occurance of srchstr
' Note: This is not as efficient as the forward seach because we must use
' GetLinePtr to get the string link pointer

PUB SearchStringBackward(pstr, linenum) | i, prev, curr
  if (not GetString(pstr))
    return PARSING_ERROR
  i := linenum - 1
  repeat while (i => 1)
    curr := GetLinePtr(i, @prev)
    if (not curr)
      c.printf1(string("SearchStringBackward: curr = 0, line = %d\n"), i)
      return - 3
    if (FindString((curr + str), @srchstr))
      return i
    i--
  i := numlines
  repeat while (i => linenum)
    curr := GetLinePtr(i, @prev)
    if (not curr)
      c.printf1(string("SearchStringBackward: curr = 0, line = %d\n"), i)
      return - 3
    if (FindString((curr + str), @srchstr))
      return i
    i--
  return PARSING_ERROR
' Parse the replace string command and extract rplcstr1 and rplcstr2

PUB ParseReplaceString(str_0) | ptr
  if (byte[str_0++] <> "s")
    return 0
  if (byte[str_0] == 0)
    return 1
  if (byte[str_0++] <> "/")
    return 0
  ptr := FindChar(str_0, "/")
  if (byte[ptr] <> "/")
    return 0
  byte[ptr++] := 0
  if (byte[str_0])
    c.strcpy(@rplcstr1, str_0)
  else
    c.strcpy(@rplcstr1, @srchstr)
  if (byte[ptr] == 0)
    return 1
  str_0 := FindChar(ptr, "/")
  if (byte[str_0] <> "/")
    return 0
  byte[str_0++] := 0
  c.strcpy(@rplcstr2, ptr)
  rflag :=(byte[str_0] == "g")
  return 1
' Store the results of the replace-string command on str1 into str2

PUB ReplaceString(str1, str2) | changeflag, len1, len2
  changeflag := 0
  len1 := strsize(@rplcstr1)
  len2 := strsize(@rplcstr2)
  ' Search through str1 for rplcstr1 and replace with rplcstr2
  repeat while (byte[str1])
    if (c.strncmp(str1, @rplcstr1, len1) == 0)
      changeflag := 1
      c.memcpy(str2, @rplcstr2, len2)
      str2 += len2
      str1 += len1
      ' Quit after the first time if 'g' was not specified
      if (not rflag)
        quit
    else
      byte[str2++] := byte[str1++]
  ' Copy the remainder of str1 to str2
  repeat while (byte[str1])
    byte[str2++] := byte[str1++]
  byte[str2] := 0
  return changeflag
' Execute the replace-string command on multiple lines in the text buffer

PUB ReplaceStringCommand(inptr, first, last, linenum) | i, lastproc, changeflag, link, prev, curr
  lastproc := linenum
  changeflag := 0
  curr := GetLinePtr(first, @prev)
  if (not ParseReplaceString(inptr))
    c.printf0(string("?\n"))
    return last
  i := first
  repeat while (i =< last)
    if (not curr)
      c.printf1(string("ReplaceStringCommand: line = %d\n"), i)
      return 1
    if (CheckMatch((curr + str), @srchstr))
      prev := curr
      curr := long[curr + next_0]
      i++
      next
    if (ReplaceString((curr + str), @inbuf))
      link := curr
      curr := smalloc(strsize(@inbuf) + 1)
      if (not curr)
        return lastproc
      c.strcpy((curr + str), @inbuf)
      if (prev)
        long[prev + next_0] := curr
      else
        ListHead := curr
      long[curr + next_0] := long[link + next_0]
      sfree(link)
      changeflag := 1
      changed := 1
    prev := curr
    curr := long[curr + next_0]
    lastproc := i
    i++
  if (not changeflag)
    c.printf0(string("?\n"))
  return lastproc
' Extract a line number parameter from a command

PUB GetLineNumber(str_0, linenum, num) | val
  if (byte[str_0][0] == ".")
    long[num] := linenum
    str_0++
  elseif (byte[str_0][0] == "-")
    str_0++
    if (c.isdigit(byte[str_0]))
      val := getnum(@str_0)
    else
      val := 1
    long[num] := linenum - val
  elseif (byte[str_0][0] == "+")
    str_0++
    if (c.isdigit(byte[str_0]))
      val := getnum(@str_0)
    else
      val := 1
    long[num] := linenum + val
  elseif (byte[str_0][0] == "$")
    long[num] := numlines
    str_0++
  elseif (byte[str_0][0] == "/")
    long[num] := SearchStringForward(@str_0, linenum)
  elseif (byte[str_0][0] == "?")
    long[num] := SearchStringBackward(@str_0, linenum)
  elseif (c.isdigit(byte[str_0]))
    long[num] := getnum(@str_0)
  else
    long[num] := UNSPECIFIED
  if (long[num] <> UNSPECIFIED and(long[num] < 0 or long[num] > numlines))
    long[num] := PARSING_ERROR
  return str_0
' Extract the first and last numbers and the command from a command string

PUB ParseCommand(pstr, linenum, first, last, cmd, bang) | done, str_0
  done := 0
  str_0 := long[pstr]
  long[bang] := 0
  if (byte[str_0] == "%")
    long[first] := 1
    long[last] := numlines
    done := 1
  elseif (byte[str_0] == ";")
    long[first] := linenum
    long[last] := numlines
    done := 1
  elseif (byte[str_0] == ",")
    long[first] := long[last] := numlines
    done := 1
  if (done)
    str_0++
    long[cmd] := byte[str_0]
    if (byte[str_0] and byte[str_0][1] == "!")
      long[bang] := 1
      str_0++
    long[pstr] := str_0
    return 1
  str_0 := GetLineNumber(str_0, linenum, first)
  if (long[first] == PARSING_ERROR)
    return 0
  if (long[first] == UNSPECIFIED)
    if (numlines == 0 and byte[str_0] == "i")
      long[first] := long[last] := 1
    elseif (byte[str_0] == "g" or byte[str_0] == "v" or byte[str_0] == "w" or byte[str_0] == "x")
      long[first] := 1
      long[last] := numlines
    elseif (byte[str_0] == "j")
      long[first] := linenum
      long[last] := linenum + 1
      if (long[last] > numlines)
        return 0
    elseif (byte[str_0] == "r")
      long[first] := numlines
      long[last] := numlines
    elseif (byte[str_0] == 0 or byte[str_0] == "z")
      long[first] := long[last] := linenum + 1
      if (long[first] > numlines)
        return 0
    elseif (byte[str_0] == "=")
      long[first] := long[last] := numlines
    else
      long[first] := linenum
      long[last] := linenum
  elseif (byte[str_0] == "," or byte[str_0] == ";")
    str_0 := GetLineNumber(str_0 + 1, linenum, last)
    if (long[last] == PARSING_ERROR)
      return 0
    if (long[last] == UNSPECIFIED)
      long[last] := long[first]
    if (long[last] <(long[first]))
      return 0
  else
    long[last] := long[first]
  long[cmd] := byte[str_0]
  if (byte[str_0] and byte[str_0][1] == "!")
    long[bang] := 1
    str_0++
  long[pstr] := str_0
  ' If first is zero, check if commands allows that
  if (long[first] == 0)
    str_0 := FindChar(string("aq=EerxQhVfP"), long[cmd])
    if (byte[str_0] == 0)
      return 0
  return 1
' Print a visualization mode screen

PUB PrintScreen(linenum) | i, num, vlines1, vlines2, first, last, linenum1, linenum2
  vlines1 := vlines - 1
  vlines2 := vlines / 2
  first := topline
  last := first + vlines1

  if termtype == 1
    PrintScreenPST(linenum, vlines1, vlines2, first, last)
  elseif termtype == 2
    PrintScreenANSI(linenum, vlines1, vlines2, first, last)
  else
    PrintScreenDumb(linenum, vlines1, vlines2, first, last)

  ' Print status line
  if (retcode < 0)
    c.printf1(string("E%d:"), - retcode)
    statuslen := 2 + NumDigits(-retcode)
    retcode := 0
  else
    c.printf3(string("line %d, column %d, %d lines"), currline, dispcol, numlines)
    statuslen := 22 + NumDigits(currline) + NumDigits(dispcol) + NumDigits(numlines)
    if (filename[0])
      c.printf1(string(", %s"), @filename)
      statuslen += strsize(@filename) + 2

  if termtype == 2
    MoveCursorANSI(currline - topline + 1, dispcol)

CON
  PST_move_up      = 5
  PST_move_down    = 6
  PST_erase_line   = 11
  PST_clear_screen = 0

PUB MoveCursorPST(row, col)
  result := c.getconfig
  c.setconfig((result & !3) | 1)
  c.putchar(2)
  c.putchar(col-1)
  c.putchar(row-1)
  c.setconfig(result)

PUB PrintScreenPST(linenum, vlines1, vlines2, first, last) | linenum1, linenum2
  if (schange > 1)
    if (schange == 2)
      linenum2 := linenum1 := linenum
    elseif (schange == 3)
      linenum1 := linenum - 1
      linenum2 := linenum
    else
      linenum1 := linenum
      linenum2 := linenum + 1
  ' Check if we need to only repaint the current line
  if (schange > 1 and linenum1 => first and linenum2 =< last)
    MoveCursorPST(linenum1 - topline + 1, 1)
    c.putchar(PST_erase_line)
    if (linenum1 <> linenum2)
      c.putchar(PST_move_down)
      c.putchar(PST_erase_line)
      c.putchar(PST_move_up)
    PrintLines(linenum, linenum1, linenum2, "v")
    EraseStatusLine
  else
    ' Clear the screen
    c.putchar(PST_clear_screen)
    PrintScreenDumb(linenum, vlines1, vlines2, first, last)

CON
  OFFSET = 0

DAT
  ANSI_move_up      byte 27, "[", "A", 0
  ANSI_move_down    byte 27, "[", "B", 0
  ANSI_erase_line   byte 27, "[", "K", 0
  ANSI_scroll_up    byte 27, "[", "9", "9", "B", 27, "D", 0
  ANSI_scroll_down  byte 27, "M", 0
  ANSI_clear_screen byte 27, "[", "2", "J", 0

PUB MoveCursorANSI(row, col)
  c.printf2(string("\033[%d;%dH"), row, col)

PUB PrintScreenANSI(linenum, vlines1, vlines2, first, last) | i, num, linenum1, linenum2
  if (schange > 1)
    if (schange == 2 or schange == 5)
      linenum2 := linenum1 := linenum
    elseif (schange == 3)
      linenum1 := linenum - 1
      linenum2 := linenum
    else
      linenum1 := linenum
      linenum2 := linenum + 1
  ' Check if we need to only repaint the current line
  if (schange > 1 and linenum1 => first and linenum2 =< last)
    if schange == 5
      EraseStatusLine
      return
    MoveCursorANSI(linenum1 - topline + 1, 1)
    c.fputs(@ANSI_erase_line, stdout)
    if (linenum1 <> linenum2)
      c.fputs(@ANSI_move_down, stdout)
      c.fputs(@ANSI_erase_line, stdout)
      c.fputs(@ANSI_move_up, stdout)
    PrintLines(linenum, linenum1, linenum2, "v")
    EraseStatusLine
  elseif schange == 5 and linenum == first - 1
    EraseStatusLine
    MoveCursorANSI(1, 1)
    c.fputs(@ANSI_scroll_down, stdout)
    MoveCursorANSI(1, 1)
    topline := --first
    last := first + vlines1
    if last > numlines
      last := numlines
    PrintLines(linenum, linenum1, linenum2, "v")
    EraseStatusLine
  elseif schange == 5 and linenum == last + 1
    'MoveCursorANSI(1, 1)
    'c.fputs(@ANSI_erase_line, stdout)
    EraseStatusLine
    c.fputs(@ANSI_scroll_up, stdout)
    'c.putchar(27)
    'c.putchar("D")
    MoveCursorANSI(vlines, 1)
    topline := ++first
    last := first + vlines1
    if last > numlines
      last := numlines
    'c.printf0(string("SU:"))
    PrintLines(linenum, linenum1, linenum2, "v")
    EraseStatusLine
  else
    ' Clear the screen
    c.fputs(@ANSI_clear_screen, stdout)
    MoveCursorANSI(1, 1)
    PrintScreenDumb(linenum, vlines1, vlines2, first, last)

PUB PrintScreenDumb(linenum, vlines1, vlines2, first, last) | i
  ' Clear the screen
  if termtype <> 1 and termtype <> 2
    i := 0
    repeat while (i < 50)
      c.printf0(string("\n"))
      i++
  ' Determine the first and last lines to display
  if (first > currline)
    first := currline
    last := first + vlines1
  elseif (currline > last)
    last := currline
    first := last - vlines1
    if (first < 1)
      first := 1
  if (last > numlines)
    last := numlines
  if (first > 0 and numlines > 0)
    topline := first
    PrintLines(linenum, first, last, "v")
  else
    last := first - 1
  i := last - first
  repeat while (i < vlines1)
    c.printf0(string("~\n"))
    i++

' Empty a list and free the string links
PUB EmptyList(list) | next_1
  repeat while (list)
    next_1 := long[list + next_0]
    sfree(list)
    list := next_1
' Delete lines from the text file list and move them to the yank list

PUB DeleteLines(first, last) | i, prev, curr, yank
  curr := GetLinePtr(first, @prev)
  yank := 0
  EmptyList(YankHead)
  YankHead := 0
  i := first
  repeat while (i =< last)
    if (not curr)
      c.printf1(string("DeleteLines: line = %d\n"), first)
      return 1
    if (not yank)
      YankHead := curr
    else
      long[yank + next_0] := curr
    yank := curr
    curr := long[curr + next_0]
    numlines--
    i++
  if (prev)
    long[prev + next_0] := curr
  else
    ListHead := curr
  long[yank + next_0] := 0
  changed := 1
  if (first > numlines)
    first := numlines
  return first
' Copy lines from the text file list to the yank list

PUB YankLines(first, last) | line, link, list, curr
  list := 0
  curr := GetLinePtr(first, @link)
  EmptyList(YankHead)
  YankHead := 0
  line := first
  repeat while (line =< last)
    if (not curr)
      c.printf1(string("YankLines: line = %d\n"), line)
      return 1
    link := DuplicateString(curr)
    if (not link)
      quit
    if (not list)
      YankHead := link
    else
      long[list + next_0] := link
    curr := long[curr + next_0]
    list := link
    line++
  if (list)
    long[list + next_0] := 0
  return last
' Copy the lines on the yank list to the text file list

PUB PushLines(line) | link, curr
  curr := YankHead
  repeat while (curr)
    link := DuplicateString(curr)
    if (not link)
      quit
    InsertLine(link,++line)
    curr := long[curr + next_0]
    changed := 1
  return line
' Go into the text input mode and append after "linenum"

PUB AppendLines(linenum) | prev, curr, link
  curr := GetLinePtr(linenum + 1, @prev)
  repeat while (1)
    c.gets(@inbuf)
    RemoveCRLF(@inbuf)
    if (inbuf[0] == "." and inbuf[1] == 0)
      quit
    link := AllocateString(@inbuf)
    if (not link)
      quit
    long[link + next_0] := curr
    if (prev)
      long[prev + next_0] := link
    else
      ListHead := link
    prev := link
    linenum++
    numlines++
    changed := 1
  return linenum
' Go into the text input mode and insert lines before "linenum"

PUB InsertLines(linenum) | linenum1
  linenum1 := AppendLines(linenum - 1)
  if (linenum1 > linenum)
    linenum := linenum1
  return linenum
' Join lines together and move the original lines to the yank buffer

PUB JoinLines(first, last) | i, len, str_0, prev, curr, link, yank
  len := 0
  curr := GetLinePtr(first, @prev)
  link := curr
  yank := 0
  EmptyList(YankHead)
  YankHead := 0
  ' Determine the total length of the selected lines
  i := first
  repeat while (i =< last)
    if (not link)
      c.printf1(string("JoinLines: line = %d\n"), i)
      return 1
    len += strsize((link + str))
    link := long[link + next_0]
    i++
  ' Allocate a new string buffer and concatenate the strings
  link := smalloc(len + 1)
  if (not link)
    return first
  str_0 :=(link + str)
  byte[str_0] := 0
  i := first
  repeat while (i =< last)
    if (not curr)
      c.printf1(string("JoinLines: line = %d\n"), i)
      return 1
    c.strcat(str_0,(curr + str))
    if (not yank)
      YankHead := curr
    else
      long[yank + next_0] := curr
    yank := curr
    curr := long[curr + next_0]
    numlines--
    changed := 1
    i++
  ' Insert the new string
  if (prev)
    long[prev + next_0] := link
  else
    ListHead := link
  long[link + next_0] := curr
  long[yank + next_0] := 0
  numlines++
  return first
' Move or copy lines to after the destination address

PUB MoveLines(first, last, dstaddr, cmd) | i, prev, curr, link, srcaddr, insertbefore
  if (dstaddr < 0 or dstaddr > numlines or(first =< dstaddr and dstaddr < last))
    c.printf0(string("?\n"))
  else
    srcaddr := first
    insertbefore := dstaddr < first
    i := first
    repeat while (i =< last)
      curr := GetLinePtr(srcaddr++, @prev)
      link := DuplicateString(curr)
      if (not link)
        quit
      InsertLine(link,++dstaddr)
      if (insertbefore)
        srcaddr++
      if (cmd == "m")
        DeleteLine(--srcaddr)
        if (not insertbefore)
          dstaddr--
      i++
    changed := 1
  return dstaddr
' Read a file after "linenum"

PUB ReadFile(fname, linenum) | numchar, infile, link
  numchar := 0
  infile := c.fopen(fname, string("r"))
  if (infile)
    repeat while (c.fgets(@inbuf, MAX_CHARS, infile))
      RemoveCRLF(@inbuf)
      link := AllocateString(@inbuf)
      if (not link)
        quit
      InsertLine(link,++linenum)
      numchar += strsize(@inbuf)
    c.fclose(infile)
  c.printf1(string("%d\n"), numchar)
  return linenum
' Write lines first to last to the output file

PUB WriteFile(fname, first, last) | i, LinePtr_0, curr, prev, numchar, outfile
  numchar := 0
  outfile := c.fopen(fname, string("w"))
  if (not outfile)
    return - 1
  i := first
  repeat while (i =< last)
    curr := GetLinePtr(i, @prev)
    LinePtr_0 :=(curr + str)
    numchar += strsize(LinePtr_0)
    c.fprintf1(outfile, string("%s\n"), LinePtr_0)
    i++
  c.fclose(outfile)
  c.printf1(string("%d\n"), numchar)
  if (first == 1 and last == numlines)
    changed := 0
  return 0
' Execute a command

PUB ExecuteCommand | curr, prev, LinePtr_0, outfile, inptr, first, last, cmd, i, temp, numchar, bang
  inptr := @inbuf
  ' Parse the command and extract the parameters
  if (not ParseCommand(@inptr, currline, @first, @last, @cmd, @bang))
    return - 2
  ' Parse a "g" or "v" command if present
  if (cmd == "g" or cmd == "v")
    inptr++
    if (GetString(@inptr))
      if (cmd == "g")
        gflag := 1
      else
        gflag := 2
      cmd := byte[inptr]
      if (cmd == 0)
        cmd := "p"
      c.printf1(string("cmd = %c\n"), cmd)
    else
      return - 3
  ' Select the command and execute it
  case(cmd)
    0 :
      ' Print the current line if no command
      if (numlines == 0)
        return - 4
      if (last => 0)
        currline := last
      elseif (first => 0)
        currline := first
      curr := GetLinePtr(currline, @prev)
      LinePtr_0 :=(curr + str)
      c.printf1(string("%s\n"), LinePtr_0)
    "q" :
      if (changed == 0 or bang)
        return 1
      return - 5
    "e" :
      if (changed and bang == 0)
        return - 6
      inptr := SkipChar(inptr + 1, " ")
      if (byte[inptr] == 0 and filename == 0)
        return - 7
      if (byte[inptr])
        c.strcpy(@filename, inptr)
      EmptyList(YankHead)
      YankHead := 0
      EmptyList(ListHead)
      ListHead := 0
      numlines := 0
      currline := ReadFile(@filename, 0)
      changed := 0
    "r" :
      ' Read the contents of a file after the specified line
      inptr := SkipChar(inptr + 1, " ")
      if (byte[inptr] == 0 and filename == 0)
        return - 8
      if (byte[inptr])
        if (not filename[0])
          c.strcpy(@filename, inptr)
      else
        inptr := @filename
      temp := numlines
      currline := ReadFile(inptr, first)
      if (temp and numlines <> temp)
        changed := 1
    "x", "w" :
      ' Write the text buffer to a file
      inptr := SkipChar(inptr + 1, " ")
      if (byte[inptr] == 0)
        if (filename == 0)
          return - 9
        inptr := @filename
      if (WriteFile(inptr, first, last) < 0)
        return - 10
      if (cmd == "x")
        return 1
      if (filename == 0)
        c.strcpy(@filename, inptr)
    "d" :
      ' Delete the specified lines
      currline := DeleteLines(first, last)
    "m", "t" :
      ' Move or copy the specified lines
      if (byte[inptr][1])
        c.sscanf1(inptr + 1, string("%d"), @temp)
      else
        temp := currline
      currline := MoveLines(first, last, temp, cmd)
    "c" :
      ' Change the specified lines
      temp :=(last == numlines)
      currline := DeleteLines(first, last)
      if (temp)
        currline := AppendLines(currline)
      else
        currline := InsertLines(currline)
    "a" :
      ' Append text after the specified line
      currline := AppendLines(first)
    "i" :
      ' Insert text before the specified line
      currline := InsertLines(first)
    "j" :
      ' Join together lines
      currline := JoinLines(first, last)
    "p", "l", "#" :
      ' Print lines in either the "p", "l" or "n" format
      currline := PrintLines(currline, first, last, cmd)
    "V" :
      ' Set the number of lines in the visualization mode or
      ' toggle the visualization mode if no lines are specified
      if (byte[inptr][1])
        c.sscanf1(inptr + 1, string("%d"), @temp)
        if (temp =< 0)
          return - 11
        vlines := temp - 1
        vmode := 1
      else
        vmode := 1
    "T" :
      ' Set the terminal type, or toggle the terminal
      ' type if no parameter is specified
      if (byte[inptr][1])
        c.sscanf1(inptr + 1, string("%d"), @termtype)
      else
        termtype := (termtype + 1) // 3
    "s" :
      ' Replace text in the specified lines
      currline := ReplaceStringCommand(inptr, first, last, currline)
    "P" :
      ' Push text from the yank buffer
      currline := PushLines(first)
    "y" :
      ' Yank lines to the yank buffer
      currline := YankLines(first, last)
    "=" :
      ' Print the number of lines, or the line number if specified
      c.printf1(string("%d\n"), last)
    OTHER :
      ' Return error code if not a valid command
      return - 14
  return 0

PUB SetDispCol | len, curr
  curr := GetLinePtr(currline, @curr)
  if (curr)
    len := strsize((curr + str))
    if (currcol > len)
      dispcol := len
    else
      dispcol := currcol
    if (dispcol < 1)
      dispcol := 1

PUB NumDigits(num)
  result := 1
  repeat while num > 9
    result++
    num /= 10

PUB EraseStatusLine | i
  if (termtype == 1)
    MoveCursorPST(vlines + 1, 1)
    c.putchar(PST_erase_line)
  elseif termtype == 2
    MoveCursorANSI(vlines + 1, 1)
    c.fputs(@ANSI_erase_line, stdout)
  else
    i := 0
    repeat while (i < statuslen)
      c.putchar(8)
      i++
    i := 0
    repeat while (i < statuslen)
      c.putchar(" ")
      i++
    i := 0
    repeat while (i < statuslen)
      c.putchar(8)
      i++

PUB ExecuteViCommand(cmd) | temp2, index, val, inptr, temp, link, i, len, curr
  inptr := @inbuf
  temp := currline
  val := 0

  ' Check for repeat command
  if cmd == "."
    ifnot lastcmd
      return
    cmd := lastcmd
    ifnot count
      count := lastcnt
    if cmd == "d"
      cmd0 := "d"
    elseif cmd == "r"
      val := lastval
    else
      cmd0 := 0

  case(cmd)
    "Q" :
      vmode := 0
      count := 0
      schange := 1
      prompt := ":"
      EraseStatusLine
    "Y" :
      if (count =< 1)
        temp2 := currline
      else
        temp2 := currline + count - 1
      if (temp2 > numlines)
        temp2 := numlines
      YankLines(currline, temp2)
      lastcmd := cmd
      lastcnt := count
      count := 0
    "p" :
      currline := PushLines(currline)
      schange :=(currline <> temp)
      lastcmd := cmd
      lastcnt := count
      count := 0
    ":" :
      vmode := - 1
      count := 0
      schange := 1
      prompt := cmd
      EraseStatusLine
    "/", "?" :
      srchdir := (cmd == "/")
      EraseStatusLine
      c.putchar(cmd)
      result := c.getconfig
      c.setconfig(result & !3)
      c.gets(inptr)
      c.setconfig(result)
      VisualSearchString(inptr, srchdir)
      count := 0
    "n" :
      byte[inptr] := 0
      VisualSearchString(inptr, srchdir)
      count := 0
    "N" :
      byte[inptr] := 0
      VisualSearchString(inptr, not srchdir)
      count := 0
    13, "j" :
      if (currline < numlines)
        currline++
        if termtype == 2
          schange := 5
        else
          schange := 3
        curr := GetLinePtr(currline, @curr)
        if (curr)
          len := strsize((curr + str))
          if (currcol > len)
            dispcol := len
          else
            dispcol := currcol
          if (dispcol < 1)
            dispcol := 1
      count := 0
    "k" :
      if (currline > 1)
        currline--
        if termtype == 2
          schange := 5
        else
          schange := 4
        curr := GetLinePtr(currline, @curr)
        if (curr)
          len := strsize((curr + str))
          if (currcol > len)
            dispcol := len
          else
            dispcol := currcol
          if (dispcol < 1)
            dispcol := 1
      count := 0
    "h" :
      if (dispcol > 1)
        dispcol--
        currcol := dispcol
        if termtype == 2
          schange := 5
        else
          schange := 2
      count := 0
    "l" :
      curr := GetLinePtr(currline, @curr)
      if (curr)
        len := strsize((curr + str))
      else
        len := 0
      if (dispcol < len)
        dispcol++
        currcol := dispcol
        if termtype == 2
          schange := 5
        else
          schange := 2
      count := 0
    6 :
      ' ^F
      currline += vlines
      if (currline > numlines)
        currline := numlines
      schange :=(currline <> temp)
      SetDispCol
      count := 0
    2 :
      ' ^B
      currline -= vlines
      if (currline < 1)
        currline := 1
      schange :=(currline <> temp)
      SetDispCol
      count := 0
    4 :
      ' ^D
      currline += vlines / 2
      if (currline > numlines)
        currline := numlines
      schange :=(currline <> temp)
      SetDispCol
      count := 0
    21 :
      ' ^U
      currline -= vlines / 2
      if (currline < 1)
        currline := 1
      schange :=(currline <> temp)
      SetDispCol
      count := 0
    "G" :
      if (count => 1 and count =< numlines)
        currline := count
      elseif (count == 0)
        currline := numlines
      schange :=(currline <> temp)
      count := 0
      SetDispCol
    "J" :
      if (count =< 1)
        temp2 := currline + 1
      else
        temp2 := currline + count
      if (temp2 > numlines)
        temp2 := numlines
      currline := JoinLines(currline, temp2)
      lastcmd := cmd
      lastcnt := count
      count := 0
      cmd0 := 0
      schange := 1
    "d" :
      if (cmd0 == "d")
        if (count =< 1)
          temp2 := currline
        else
          temp2 := currline + count - 1
        if (temp2 > numlines)
          temp2 := numlines
        currline := DeleteLines(currline, temp2)
        lastcmd := cmd
        lastcnt := count
        count := 0
        cmd0 := 0
        schange := 1
        SetDispCol
        return
    "x" :
      if (curr := GetLinePtr(currline, @curr))
        inptr :=(curr + str)
        len := strsize(inptr)
        lastcmd := cmd
        lastcnt := count
        if count =< 0
          count := 1
        if (len)
          changed := 1
          index := dispcol - 1
          if dispcol + count - 1 > len
            count := len - dispcol + 1
          len -= count
          repeat while (index =< len)
            byte[inptr][index] := byte[inptr][index + count]
            index++
          schange := 2
          if (dispcol > len and len > 0)
            dispcol := len
          currcol := dispcol
        count := 0
    "r" :
      if (curr := GetLinePtr(currline, @curr))
        inptr :=(curr + str)
        len := strsize(inptr)
        ifnot val
          val := c.getchar
        lastcmd := cmd
        lastcnt := count
        lastval := val
        if (val <> 27)
          schange := 2
          changed := 1
          if (len)
            index := dispcol - 1
            byte[inptr][index] := val
          else
            link := AllocateString(string(" "))
            byte[link + str][0] := val
            InsertLine(link, currline)
            DeleteLine(currline + 1)
          currcol := dispcol
      count := 0
    "O", "A", "I", "i", "a" :
      count := 0
      changed := 1
      if (numlines == 0)
        index := 0
        inbuf[0] := 0
        len := 0
        currline := 1
        schange := 1
      elseif (cmd == "O")
        index := 0
        inbuf[0] := 0
        len := 0
        schange := 1
      else
        link := GetLinePtr(currline, @link)
        c.strcpy(@inbuf,(link + str))
        len := strsize(@inbuf)
        if (cmd == "A")
          index := len
        else
          if (len == 0 or cmd == "I")
            index := 0
          else
            index := dispcol
            if (cmd == "i")
              index--
        DeleteLine(currline)
        schange := 2
      currcol := dispcol := index + 1
      repeat while (1)
        link := AllocateString(@inbuf)
        InsertLine(link, currline)
        PrintScreen(currline)
        val := c.getchar
        if (val == 27)
          if (len > 0 and index => len)
            index--
            schange := 2
            dispcol := currcol := index + 1
          quit
        if (val == 8)
          if (index > 0)
            index--
            i := index
            repeat while (i < len)
              inbuf[i] := inbuf[i + 1]
              i++
            len--
          DeleteLine(currline)
          schange := 2
        elseif (val == 13)
          if (index == 0)
            link := AllocateString(@nullstr)
            InsertLine(link, currline)
            currline++
            DeleteLine(currline)
          else
            i := len + 1
            repeat while (i > index)
              inbuf[i] := inbuf[i - 1]
              i--
            inbuf[index++] := 0
            len++
            link := AllocateString(@inbuf)
            InsertLine(link, currline)
            currline++
            DeleteLine(currline)
            len -= index
            i := 0
            repeat while (i =< len)
              inbuf[i] := inbuf[i + index]
              i++
            index := 0
          schange := 1
        else
          i := len + 1
          repeat while (i > index)
            inbuf[i] := inbuf[i - 1]
            i--
          inbuf[index++] := val
          len++
          DeleteLine(currline)
          schange := 2
        dispcol := currcol := index + 1
    "$" :
      curr := GetLinePtr(currline, @curr)
      if (curr)
        len := strsize((curr + str))
        if (not len)
          len++
        if (len <> dispcol)
          dispcol := len
          currcol := dispcol
          schange := 1
      count := 0
    OTHER :
      if (c.isdigit(cmd))
        if (count == 0 and cmd == "0")
          if (dispcol <> 1)
            dispcol := 1
            currcol := dispcol
            schange := 1
        count :=(count * 10) + cmd - "0"
  cmd0 := cmd

PUB FindNextString(dir, newline) | curr, prev, lineptr, len
  if (curr := GetLinePtr(currline, @prev))
    lineptr := curr + str
    len := strsize(lineptr)
    if dir
      if newline
        dispcol := currcol := 1
      if dispcol < len
        prev := FindString(lineptr + dispcol, @srchstr)
        if prev
          result := dispcol + prev
    else
      if newline
        dispcol := currcol := len + 1
      if dispcol  > 1
        prev := FindStringBackward(lineptr, @srchstr, dispcol - 1)
        if prev
          result := prev

PUB VisualSearchString(ptr, dir) | newline, oldline, newcol
  if byte[ptr]
    c.strcpy(@srchstr, ptr)

  ' Search current line
  if (newcol := FindNextString(dir, 0))
    if termtype == 2
      schange := 5
    else
      schange := 1
    currcol := dispcol := newcol
    return

  ' Search other lines
  c.strcpy(ptr, string("//"))
  oldline := currline
  if dir
    newline := SearchStringForward(@ptr, currline)
  else
    newline := SearchStringBackward(@ptr, currline)

  ' Search for first occurance on new line
  if newline > 0 and newline <> currline
    if termtype == 2
      schange := 5
    else
      schange := 1
    currline := newline
    if (newcol := FindNextString(dir, 1))
      currcol := dispcol := newcol
  else
    if termtype == 2
      schange := 5
    else
      schange := 2

'******************************************************************************
' String Allocation Routines
' Copyright (c) 2011, Dave Hein
' See end of file for terms of use.
'******************************************************************************
VAR
  long smfreelist

PUB smallocinit(ptr, size_0) | curr
  curr := ptr
  smfreelist := curr
  long[curr + next_0] := 0
  long[curr + size] := size_0
' Allocate a block of "size" bytes.  Return a pointer to the block if
' successful, or zero if a large enough memory block could not be found

PUB smalloc(size_0) | prev, curr, next_1
  'printf("smalloc: %d\n", size);
  if (size_0 =< 0)
    return 0
  ' Adjust size to nearest long plus the header size
  size_0 :=((size_0 + 3) &(! 3)) + HDR_SIZE
  ' Search for a block of memory
  prev := 0
  curr := smfreelist
  repeat while (curr)
    if (long[curr + size] => size_0)
      quit
    prev := curr
    curr := long[curr + next_0]
  ' Return null if block not found
  if (curr == 0)
    c.printf0(string("Out of memory!\n"))
    return 0
  ' Get next pointer
  next_1 := long[curr + next_0]
  ' Split block if larger than needed
  if (long[curr + size] => size_0 + HDR_SIZE + 16)
    next_1 :=(((curr) + size_0))
    long[next_1 + next_0] := long[curr + next_0]
    long[next_1 + size] := long[curr + size] - size_0
    long[curr + next_0] := next_1
    long[curr + size] := size_0
  ' Remove block from the free list
  long[curr + next_0] := 0
  if (prev)
    long[prev + next_0] := next_1
  else
    smfreelist := next_1
  return curr
' Insert a memory block back into the free list.  Merge blocks together if
' the memory block is contiguous with other blocks on the list.

PUB sfree(curr) | prev, next_1
  prev := 0
  next_1 := smfreelist
  ' Find Insertion Point
  repeat while (next_1)
    if (curr => prev and curr =< next_1)
      quit
    prev := next_1
    next_1 := long[next_1 + next_0]
  ' Merge with the previous block if contiguous
  if (prev and(((prev) + long[prev + size])) == curr)
    long[prev + size] += long[curr + size]
    ' Also merge with next block if contiguous
    if ((((prev) + long[prev + size])) == next_1)
      long[prev + size] += long[next_1 + size]
      long[prev + next_0] := long[next_1 + next_0]
  ' Merge with the next block if contiguous
  elseif (next_1 and(((curr) + long[curr + size])) == next_1)
    long[curr + size] += long[next_1 + size]
    long[curr + next_0] := long[next_1 + next_0]
    if (prev)
      long[prev + next_0] := curr
    else
      smfreelist := curr
  ' Insert in the middle of the free list if not contiguous
  elseif (prev)
    long[prev + next_0] := curr
    long[curr + next_0] := next_1
  ' Otherwise, insert at beginning of the free list
  else
    smfreelist := curr
    long[curr + next_0] := next_1
{
+----------------------------------------------------------------------------+
|                          TERMS OF USE: MIT License                         |
+----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy|
|of this software and associated documentation files (the "Software"), to    |
|deal in the Software without restriction, including without limitation the  |
|rights to use, copy, modify, merge, publish, distribute, sublicense, and/or |
|sell copies of the Software, and to permit persons to whom the Software is  |
|furnished to do so, subject to the following conditions:                    |
|                                                                            |
|The above copyright notice and this permission notice shall be included in  |
|all copies or substantial portions of the Software.                         |
|                                                                            |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR  |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,    |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER      |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING     |
|FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS|
|IN THE SOFTWARE.                                                            |
+----------------------------------------------------------------------------+
}
