'******************************************************************************
' Copyright (c) 2013, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c : "clibsd"
  g : "glob"

PUB main(argc, argv) | i, j, infile, num, buffer[5], str[25], fname, globdata, numchar, numline, numword, val, wordflag, totchar, totline, totword, totfile

  c.enter

  if argc < 2
    c.printf0(string("usage: wc [FILE]...\n"))

  i := 1
  totfile := totchar := totline := totword := 0
  repeat
    globdata := 0
    repeat while (fname := g.glob(long[argv][i], @globdata, @str))
      infile := c.fopen(fname, string("r"))
      if (infile == 0)
        c.printf1(string("Error opening %s\n"), fname)
        c.exit(1)
      if c.getmod(fname) & $10 ' Check if it's a directory
        c.printf1(string("%s is a directory\n"), fname)
        c.fclose(infile)
        next

      ' Read 20 characters at a time
      wordflag := numchar := numline := numword := 0
      repeat while ((num := c.fread(@buffer, 1, 20, infile)) > 0)
        numchar += num
        repeat j from 0 to num - 1
          val := byte[@buffer][j]
          if val == 10
            numline++
            wordflag := 0
          elseif whitespace(val)
            wordflag := 0
          elseifnot wordflag
            wordflag := 1
            numword++

      c.fclose(infile)
      c.printf4(string("%4d %5d %6d %s\n"), numline, numword, numchar, fname)
      totline += numline
      totword += numword
      totchar += numchar
      totfile++

  while (++i < argc)

  if totfile > 1
    c.printf3(string("%4d %5d %6d total\n"), totline, totword, totchar)

  c.exit(0)

PUB whitespace(val)
  return val =< 32

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
